// Compiled shader for all platforms, uncompressed size: 152.5KB

Shader "Sky/AtmosphereGhoss" {
SubShader { 
 Tags { "QUEUE"="Transparent-5" "IgnoreProjector"="True" "RenderType"="Transparent" }


 // Stats for Vertex shader:
 //       d3d11 : 15 math
 //        d3d9 : 20 math, 1 branch
 // Stats for Fragment shader:
 //       d3d11 : 149 math, 1 texture, 2 branch
 //        d3d9 : 236 math, 1 texture, 1 branch
 Pass {
  Tags { "QUEUE"="Transparent-5" "IgnoreProjector"="True" "RenderType"="Transparent" }
  ZWrite Off
  Cull Front
  Fog { Mode Off }
  Blend DstColor Zero
Program "vp" {
SubProgram "opengl " {
"!!GLSL
#ifdef VERTEX
uniform vec4 _ProjectionParams;


varying vec4 xlv_TEXCOORD0;
varying vec2 xlv_TEXCOORD1;
varying vec2 xlv_TEXCOORD2;
void main ()
{
  vec4 tmpvar_1;
  vec4 tmpvar_2;
  tmpvar_2 = (gl_ModelViewProjectionMatrix * gl_Vertex);
  vec4 o_3;
  vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((gl_ModelViewMatrix * gl_Vertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}


#endif
#ifdef FRAGMENT
#extension GL_ARB_shader_texture_lod : enable
uniform float HR;
uniform vec3 betaR;
uniform float HM;
uniform vec3 betaMEx;
uniform float Rg;
uniform float Rt;
uniform mat4 _ViewProjInv;
uniform float _experimentalAtmoScale;
uniform vec3 _camPos;
uniform float _Post_Extinction_Tint;
uniform float postExtinctionMultiplier;
uniform sampler2D _customDepthTexture;
varying vec2 xlv_TEXCOORD2;
void main ()
{
  vec4 tmpvar_1;
  vec3 worldPos_2;
  bool infinite_3;
  vec4 tmpvar_4;
  tmpvar_4 = texture2D (_customDepthTexture, xlv_TEXCOORD2);
  infinite_3 = (tmpvar_4.x == 1.0);
  vec4 tmpvar_5;
  tmpvar_5.w = 1.0;
  tmpvar_5.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_5.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_5.z = tmpvar_4.x;
  vec4 tmpvar_6;
  tmpvar_6 = (_ViewProjInv * tmpvar_5);
  vec3 tmpvar_7;
  tmpvar_7 = (tmpvar_6 / tmpvar_6.w).xyz;
  worldPos_2 = tmpvar_7;
  float tmpvar_8;
  vec3 tmpvar_9;
  tmpvar_9 = (tmpvar_7 - _camPos);
  float tmpvar_10;
  tmpvar_10 = dot (tmpvar_9, tmpvar_9);
  float tmpvar_11;
  tmpvar_11 = (2.0 * dot (tmpvar_9, _camPos));
  float tmpvar_12;
  tmpvar_12 = ((tmpvar_11 * tmpvar_11) - ((4.0 * tmpvar_10) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_12 < 0.0)) {
    tmpvar_8 = -1.0;
  } else {
    tmpvar_8 = ((-(tmpvar_11) - sqrt(tmpvar_12)) / (2.0 * tmpvar_10));
  };
  bool tmpvar_13;
  tmpvar_13 = (tmpvar_8 > 0.0);
  if ((!(tmpvar_13) && infinite_3)) {
    tmpvar_1 = vec4(1.0, 1.0, 1.0, 1.0);
  } else {
    vec3 tmpvar_14;
    tmpvar_14 = (_camPos + (tmpvar_8 * (tmpvar_7 - _camPos)));
    vec3 arg0_15;
    arg0_15 = (tmpvar_14 - _camPos);
    vec3 arg0_16;
    arg0_16 = (tmpvar_7 - _camPos);
    bool tmpvar_17;
    tmpvar_17 = (sqrt(dot (arg0_15, arg0_15)) < sqrt(dot (arg0_16, arg0_16)));
    if ((tmpvar_13 && tmpvar_17)) {
      worldPos_2 = tmpvar_14;
    };
    float tmpvar_18;
    tmpvar_18 = sqrt(dot (worldPos_2, worldPos_2));
    if ((tmpvar_18 < (Rg + 10.0))) {
      worldPos_2 = ((Rg + 10.0) * normalize(worldPos_2));
    };
    vec3 camera_19;
    camera_19 = _camPos;
    vec3 _point_20;
    _point_20 = worldPos_2;
    vec3 extinction_21;
    float mu_22;
    float rMu_23;
    float r_24;
    float d_25;
    extinction_21 = vec3(1.0, 1.0, 1.0);
    vec3 tmpvar_26;
    tmpvar_26 = (worldPos_2 - _camPos);
    float tmpvar_27;
    tmpvar_27 = sqrt(dot (tmpvar_26, tmpvar_26));
    d_25 = tmpvar_27;
    float tmpvar_28;
    tmpvar_28 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    vec3 tmpvar_29;
    tmpvar_29 = normalize((tmpvar_26 / tmpvar_27));
    float tmpvar_30;
    tmpvar_30 = sqrt(dot (_camPos, _camPos));
    r_24 = tmpvar_30;
    if ((tmpvar_30 < (0.9 * Rg))) {
      camera_19.y = (_camPos.y + Rg);
      _point_20.y = (worldPos_2.y + Rg);
      r_24 = sqrt(dot (camera_19, camera_19));
    };
    float tmpvar_31;
    tmpvar_31 = dot (camera_19, tmpvar_29);
    rMu_23 = tmpvar_31;
    mu_22 = (tmpvar_31 / r_24);
    vec3 tmpvar_32;
    tmpvar_32 = (_point_20 - (tmpvar_29 * clamp (1.0, 0.0, tmpvar_27)));
    _point_20 = tmpvar_32;
    float f_33;
    f_33 = (((tmpvar_31 * tmpvar_31) - (r_24 * r_24)) + (tmpvar_28 * tmpvar_28));
    float tmpvar_34;
    if ((f_33 >= 0.0)) {
      tmpvar_34 = sqrt(f_33);
    } else {
      tmpvar_34 = 1e+30;
    };
    float tmpvar_35;
    tmpvar_35 = max ((-(tmpvar_31) - tmpvar_34), 0.0);
    if (((tmpvar_35 > 0.0) && (tmpvar_35 < tmpvar_27))) {
      camera_19 = (camera_19 + (tmpvar_35 * tmpvar_29));
      float tmpvar_36;
      tmpvar_36 = (tmpvar_31 + tmpvar_35);
      rMu_23 = tmpvar_36;
      mu_22 = (tmpvar_36 / tmpvar_28);
      r_24 = tmpvar_28;
      d_25 = (tmpvar_27 - tmpvar_35);
    };
    if ((r_24 < (Rg + 1600.0))) {
      float tmpvar_37;
      tmpvar_37 = ((Rg + 1600.0) / r_24);
      r_24 = (r_24 * tmpvar_37);
      rMu_23 = (rMu_23 * tmpvar_37);
      _point_20 = (tmpvar_32 * tmpvar_37);
    };
    float tmpvar_38;
    vec2 tmpvar_39;
    tmpvar_39.x = mu_22;
    tmpvar_39.y = (mu_22 + (d_25 / r_24));
    vec2 tmpvar_40;
    tmpvar_40 = (sqrt(((0.5 / HR) * r_24)) * tmpvar_39);
    vec2 tmpvar_41;
    tmpvar_41 = sign(tmpvar_40);
    vec2 tmpvar_42;
    tmpvar_42 = (tmpvar_40 * tmpvar_40);
    float tmpvar_43;
    if ((tmpvar_41.y > tmpvar_41.x)) {
      tmpvar_43 = exp(tmpvar_42.x);
    } else {
      tmpvar_43 = 0.0;
    };
    vec2 tmpvar_44;
    tmpvar_44.x = 1.0;
    tmpvar_44.y = exp(((-(d_25) / HR) * ((d_25 / (2.0 * r_24)) + mu_22)));
    tmpvar_38 = ((sqrt(((6.2831 * HR) * r_24)) * exp(((Rg - r_24) / HR))) * (tmpvar_43 + dot (((tmpvar_41 / ((2.3193 * abs(tmpvar_40)) + sqrt(((1.52 * tmpvar_42) + 4.0)))) * tmpvar_44), vec2(1.0, -1.0))));
    vec2 tmpvar_45;
    tmpvar_45.x = mu_22;
    tmpvar_45.y = (mu_22 + (d_25 / r_24));
    vec2 tmpvar_46;
    tmpvar_46 = (sqrt(((0.5 / HM) * r_24)) * tmpvar_45);
    vec2 tmpvar_47;
    tmpvar_47 = sign(tmpvar_46);
    vec2 tmpvar_48;
    tmpvar_48 = (tmpvar_46 * tmpvar_46);
    float tmpvar_49;
    if ((tmpvar_47.y > tmpvar_47.x)) {
      tmpvar_49 = exp(tmpvar_48.x);
    } else {
      tmpvar_49 = 0.0;
    };
    vec2 tmpvar_50;
    tmpvar_50.x = 1.0;
    tmpvar_50.y = exp(((-(d_25) / HM) * ((d_25 / (2.0 * r_24)) + mu_22)));
    extinction_21 = min (exp(((-(betaR) * tmpvar_38) - (betaMEx * ((sqrt(((6.2831 * HM) * r_24)) * exp(((Rg - r_24) / HM))) * (tmpvar_49 + dot (((tmpvar_47 / ((2.3193 * abs(tmpvar_46)) + sqrt(((1.52 * tmpvar_48) + 4.0)))) * tmpvar_50), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    vec4 tmpvar_51;
    tmpvar_51.w = 1.0;
    tmpvar_51.xyz = vec3(mix (1.0, mix ((((extinction_21.x + extinction_21.y) + extinction_21.z) / 3.0), extinction_21.x, _Post_Extinction_Tint), postExtinctionMultiplier));
    tmpvar_1 = tmpvar_51;
  };
  gl_FragData[0] = tmpvar_1;
}


#endif
"
}
SubProgram "d3d9 " {
// Stats: 20 math, 1 branches
Bind "vertex" Vertex
Matrix 0 [glstate_matrix_modelview0]
Matrix 4 [glstate_matrix_mvp]
Vector 8 [_ProjectionParams]
Vector 9 [_ScreenParams]
Vector 10 [_MainTex_TexelSize]
"vs_3_0
dcl_position o0
dcl_texcoord0 o1
dcl_texcoord1 o2
dcl_texcoord2 o3
def c11, 0.50000000, 0.00000000, 1.00000000, 0
dcl_position0 v0
dp4 r1.z, v0, c7
dp4 r0.x, v0, c4
rcp r0.z, r1.z
mov r0.w, r1.z
dp4 r0.y, v0, c5
mul r2.xyz, r0.xyww, c11.x
mov r1.w, c11.y
mov r1.x, r2
mul r1.y, r2, c8.x
mad r1.xy, r2.z, c9.zwzw, r1
mul r2.zw, r1.xyxy, r0.z
mov r2.xy, r2.zwzw
dp4 r0.z, v0, c6
if_lt c10.y, r1.w
add r2.y, -r2, c11.z
endif
mov o0, r0
dp4 r0.x, v0, c2
mov o1.xyw, r1.xyzz
mov o2.xy, r2
mov o3.xy, r2.zwzw
mov o1.z, -r0.x
"
}
SubProgram "d3d11 " {
// Stats: 15 math
Bind "vertex" Vertex
ConstBuffer "$Globals" 400
Vector 304 [_MainTex_TexelSize]
ConstBuffer "UnityPerCamera" 128
Vector 80 [_ProjectionParams]
ConstBuffer "UnityPerDraw" 336
Matrix 0 [glstate_matrix_mvp]
Matrix 64 [glstate_matrix_modelview0]
BindCB  "$Globals" 0
BindCB  "UnityPerCamera" 1
BindCB  "UnityPerDraw" 2
"vs_4_0
eefiecedhbeoekmaekcmlodplodmclggkniidjejabaaaaaabmaeaaaaadaaaaaa
cmaaaaaakaaaaaaaciabaaaaejfdeheogmaaaaaaadaaaaaaaiaaaaaafaaaaaaa
aaaaaaaaaaaaaaaaadaaaaaaaaaaaaaaapapaaaafjaaaaaaaaaaaaaaaaaaaaaa
adaaaaaaabaaaaaaahaaaaaagaaaaaaaaaaaaaaaaaaaaaaaadaaaaaaacaaaaaa
apaaaaaafaepfdejfeejepeoaaeoepfcenebemaafeeffiedepepfceeaaklklkl
epfdeheoiaaaaaaaaeaaaaaaaiaaaaaagiaaaaaaaaaaaaaaabaaaaaaadaaaaaa
aaaaaaaaapaaaaaaheaaaaaaaaaaaaaaaaaaaaaaadaaaaaaabaaaaaaapaaaaaa
heaaaaaaabaaaaaaaaaaaaaaadaaaaaaacaaaaaaadamaaaaheaaaaaaacaaaaaa
aaaaaaaaadaaaaaaacaaaaaaamadaaaafdfgfpfaepfdejfeejepeoaafeeffied
epepfceeaaklklklfdeieefcomacaaaaeaaaabaallaaaaaafjaaaaaeegiocaaa
aaaaaaaabeaaaaaafjaaaaaeegiocaaaabaaaaaaagaaaaaafjaaaaaeegiocaaa
acaaaaaaaiaaaaaafpaaaaadpcbabaaaaaaaaaaaghaaaaaepccabaaaaaaaaaaa
abaaaaaagfaaaaadpccabaaaabaaaaaagfaaaaaddccabaaaacaaaaaagfaaaaad
mccabaaaacaaaaaagiaaaaacacaaaaaadiaaaaaipcaabaaaaaaaaaaafgbfbaaa
aaaaaaaaegiocaaaacaaaaaaabaaaaaadcaaaaakpcaabaaaaaaaaaaaegiocaaa
acaaaaaaaaaaaaaaagbabaaaaaaaaaaaegaobaaaaaaaaaaadcaaaaakpcaabaaa
aaaaaaaaegiocaaaacaaaaaaacaaaaaakgbkbaaaaaaaaaaaegaobaaaaaaaaaaa
dcaaaaakpcaabaaaaaaaaaaaegiocaaaacaaaaaaadaaaaaapgbpbaaaaaaaaaaa
egaobaaaaaaaaaaadgaaaaafpccabaaaaaaaaaaaegaobaaaaaaaaaaadiaaaaai
ecaabaaaaaaaaaaabkbabaaaaaaaaaaackiacaaaacaaaaaaafaaaaaadcaaaaak
ecaabaaaaaaaaaaackiacaaaacaaaaaaaeaaaaaaakbabaaaaaaaaaaackaabaaa
aaaaaaaadcaaaaakecaabaaaaaaaaaaackiacaaaacaaaaaaagaaaaaackbabaaa
aaaaaaaackaabaaaaaaaaaaadcaaaaakecaabaaaaaaaaaaackiacaaaacaaaaaa
ahaaaaaadkbabaaaaaaaaaaackaabaaaaaaaaaaadgaaaaageccabaaaabaaaaaa
ckaabaiaebaaaaaaaaaaaaaadiaaaaaiccaabaaaaaaaaaaabkaabaaaaaaaaaaa
akiacaaaabaaaaaaafaaaaaadiaaaaakncaabaaaabaaaaaaagahbaaaaaaaaaaa
aceaaaaaaaaaaadpaaaaaaaaaaaaaadpaaaaaadpaaaaaaahdcaabaaaaaaaaaaa
kgakbaaaabaaaaaamgaabaaaabaaaaaadgaaaaaflccabaaaabaaaaaaegambaaa
aaaaaaaaaoaaaaahhcaabaaaaaaaaaaaagabbaaaaaaaaaaapgapbaaaaaaaaaaa
aaaaaaaiicaabaaaaaaaaaaackaabaiaebaaaaaaaaaaaaaaabeaaaaaaaaaiadp
dbaaaaaibcaabaaaabaaaaaabkiacaaaaaaaaaaabdaaaaaaabeaaaaaaaaaaaaa
dhaaaaajcccabaaaacaaaaaaakaabaaaabaaaaaadkaabaaaaaaaaaaackaabaaa
aaaaaaaadgaaaaafnccabaaaacaaaaaaagajbaaaaaaaaaaadoaaaaab"
}
SubProgram "gles " {
"!!GLES


#ifdef VERTEX

attribute vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
varying highp vec4 xlv_TEXCOORD0;
varying highp vec2 xlv_TEXCOORD1;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

#extension GL_EXT_shader_texture_lod : enable
uniform highp float HR;
uniform highp vec3 betaR;
uniform highp float HM;
uniform highp vec3 betaMEx;
uniform highp float Rg;
uniform highp float Rt;
uniform highp mat4 _ViewProjInv;
uniform highp float _experimentalAtmoScale;
uniform highp vec3 _camPos;
uniform highp float _Post_Extinction_Tint;
uniform highp float postExtinctionMultiplier;
uniform sampler2D _customDepthTexture;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp vec3 worldPos_2;
  bool infinite_3;
  highp float depth_4;
  lowp float tmpvar_5;
  tmpvar_5 = texture2D (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_4 = tmpvar_5;
  infinite_3 = (depth_4 == 1.0);
  highp vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_6.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_6.z = depth_4;
  highp vec4 tmpvar_7;
  tmpvar_7 = (_ViewProjInv * tmpvar_6);
  highp vec3 tmpvar_8;
  tmpvar_8 = (tmpvar_7 / tmpvar_7.w).xyz;
  worldPos_2 = tmpvar_8;
  highp float tmpvar_9;
  highp vec3 tmpvar_10;
  tmpvar_10 = (tmpvar_8 - _camPos);
  highp float tmpvar_11;
  tmpvar_11 = dot (tmpvar_10, tmpvar_10);
  highp float tmpvar_12;
  tmpvar_12 = (2.0 * dot (tmpvar_10, _camPos));
  highp float tmpvar_13;
  tmpvar_13 = ((tmpvar_12 * tmpvar_12) - ((4.0 * tmpvar_11) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_13 < 0.0)) {
    tmpvar_9 = -1.0;
  } else {
    tmpvar_9 = ((-(tmpvar_12) - sqrt(tmpvar_13)) / (2.0 * tmpvar_11));
  };
  bool tmpvar_14;
  tmpvar_14 = (tmpvar_9 > 0.0);
  if ((!(tmpvar_14) && infinite_3)) {
    tmpvar_1 = vec4(1.0, 1.0, 1.0, 1.0);
  } else {
    highp vec3 tmpvar_15;
    tmpvar_15 = (_camPos + (tmpvar_9 * (tmpvar_8 - _camPos)));
    highp vec3 arg0_16;
    arg0_16 = (tmpvar_15 - _camPos);
    highp vec3 arg0_17;
    arg0_17 = (tmpvar_8 - _camPos);
    bool tmpvar_18;
    tmpvar_18 = (sqrt(dot (arg0_16, arg0_16)) < sqrt(dot (arg0_17, arg0_17)));
    if ((tmpvar_14 && tmpvar_18)) {
      worldPos_2 = tmpvar_15;
    };
    highp float tmpvar_19;
    tmpvar_19 = sqrt(dot (worldPos_2, worldPos_2));
    if ((tmpvar_19 < (Rg + 10.0))) {
      worldPos_2 = ((Rg + 10.0) * normalize(worldPos_2));
    };
    highp vec3 camera_20;
    camera_20 = _camPos;
    highp vec3 _point_21;
    _point_21 = worldPos_2;
    highp vec3 extinction_22;
    highp float mu_23;
    highp float rMu_24;
    highp float r_25;
    highp float d_26;
    extinction_22 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_27;
    tmpvar_27 = (worldPos_2 - _camPos);
    highp float tmpvar_28;
    tmpvar_28 = sqrt(dot (tmpvar_27, tmpvar_27));
    d_26 = tmpvar_28;
    highp float tmpvar_29;
    tmpvar_29 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    highp vec3 tmpvar_30;
    tmpvar_30 = normalize((tmpvar_27 / tmpvar_28));
    highp float tmpvar_31;
    tmpvar_31 = sqrt(dot (_camPos, _camPos));
    r_25 = tmpvar_31;
    if ((tmpvar_31 < (0.9 * Rg))) {
      camera_20.y = (_camPos.y + Rg);
      _point_21.y = (worldPos_2.y + Rg);
      r_25 = sqrt(dot (camera_20, camera_20));
    };
    highp float tmpvar_32;
    tmpvar_32 = dot (camera_20, tmpvar_30);
    rMu_24 = tmpvar_32;
    mu_23 = (tmpvar_32 / r_25);
    highp vec3 tmpvar_33;
    tmpvar_33 = (_point_21 - (tmpvar_30 * clamp (1.0, 0.0, tmpvar_28)));
    _point_21 = tmpvar_33;
    highp float f_34;
    f_34 = (((tmpvar_32 * tmpvar_32) - (r_25 * r_25)) + (tmpvar_29 * tmpvar_29));
    highp float tmpvar_35;
    if ((f_34 >= 0.0)) {
      tmpvar_35 = sqrt(f_34);
    } else {
      tmpvar_35 = 1e+30;
    };
    highp float tmpvar_36;
    tmpvar_36 = max ((-(tmpvar_32) - tmpvar_35), 0.0);
    if (((tmpvar_36 > 0.0) && (tmpvar_36 < tmpvar_28))) {
      camera_20 = (camera_20 + (tmpvar_36 * tmpvar_30));
      highp float tmpvar_37;
      tmpvar_37 = (tmpvar_32 + tmpvar_36);
      rMu_24 = tmpvar_37;
      mu_23 = (tmpvar_37 / tmpvar_29);
      r_25 = tmpvar_29;
      d_26 = (tmpvar_28 - tmpvar_36);
    };
    if ((r_25 < (Rg + 1600.0))) {
      highp float tmpvar_38;
      tmpvar_38 = ((Rg + 1600.0) / r_25);
      r_25 = (r_25 * tmpvar_38);
      rMu_24 = (rMu_24 * tmpvar_38);
      _point_21 = (tmpvar_33 * tmpvar_38);
    };
    highp float tmpvar_39;
    highp vec2 tmpvar_40;
    tmpvar_40.x = mu_23;
    tmpvar_40.y = (mu_23 + (d_26 / r_25));
    highp vec2 tmpvar_41;
    tmpvar_41 = (sqrt(((0.5 / HR) * r_25)) * tmpvar_40);
    highp vec2 tmpvar_42;
    tmpvar_42 = sign(tmpvar_41);
    highp vec2 tmpvar_43;
    tmpvar_43 = (tmpvar_41 * tmpvar_41);
    highp float tmpvar_44;
    if ((tmpvar_42.y > tmpvar_42.x)) {
      tmpvar_44 = exp(tmpvar_43.x);
    } else {
      tmpvar_44 = 0.0;
    };
    highp vec2 tmpvar_45;
    tmpvar_45.x = 1.0;
    tmpvar_45.y = exp(((-(d_26) / HR) * ((d_26 / (2.0 * r_25)) + mu_23)));
    tmpvar_39 = ((sqrt(((6.2831 * HR) * r_25)) * exp(((Rg - r_25) / HR))) * (tmpvar_44 + dot (((tmpvar_42 / ((2.3193 * abs(tmpvar_41)) + sqrt(((1.52 * tmpvar_43) + 4.0)))) * tmpvar_45), vec2(1.0, -1.0))));
    highp vec2 tmpvar_46;
    tmpvar_46.x = mu_23;
    tmpvar_46.y = (mu_23 + (d_26 / r_25));
    highp vec2 tmpvar_47;
    tmpvar_47 = (sqrt(((0.5 / HM) * r_25)) * tmpvar_46);
    highp vec2 tmpvar_48;
    tmpvar_48 = sign(tmpvar_47);
    highp vec2 tmpvar_49;
    tmpvar_49 = (tmpvar_47 * tmpvar_47);
    highp float tmpvar_50;
    if ((tmpvar_48.y > tmpvar_48.x)) {
      tmpvar_50 = exp(tmpvar_49.x);
    } else {
      tmpvar_50 = 0.0;
    };
    highp vec2 tmpvar_51;
    tmpvar_51.x = 1.0;
    tmpvar_51.y = exp(((-(d_26) / HM) * ((d_26 / (2.0 * r_25)) + mu_23)));
    extinction_22 = min (exp(((-(betaR) * tmpvar_39) - (betaMEx * ((sqrt(((6.2831 * HM) * r_25)) * exp(((Rg - r_25) / HM))) * (tmpvar_50 + dot (((tmpvar_48 / ((2.3193 * abs(tmpvar_47)) + sqrt(((1.52 * tmpvar_49) + 4.0)))) * tmpvar_51), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    highp vec4 tmpvar_52;
    tmpvar_52.w = 1.0;
    tmpvar_52.xyz = vec3(mix (1.0, mix ((((extinction_22.x + extinction_22.y) + extinction_22.z) / 3.0), extinction_22.x, _Post_Extinction_Tint), postExtinctionMultiplier));
    tmpvar_1 = tmpvar_52;
  };
  gl_FragData[0] = tmpvar_1;
}



#endif"
}
SubProgram "glesdesktop " {
"!!GLES


#ifdef VERTEX

attribute vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
varying highp vec4 xlv_TEXCOORD0;
varying highp vec2 xlv_TEXCOORD1;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

#extension GL_EXT_shader_texture_lod : enable
uniform highp float HR;
uniform highp vec3 betaR;
uniform highp float HM;
uniform highp vec3 betaMEx;
uniform highp float Rg;
uniform highp float Rt;
uniform highp mat4 _ViewProjInv;
uniform highp float _experimentalAtmoScale;
uniform highp vec3 _camPos;
uniform highp float _Post_Extinction_Tint;
uniform highp float postExtinctionMultiplier;
uniform sampler2D _customDepthTexture;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp vec3 worldPos_2;
  bool infinite_3;
  highp float depth_4;
  lowp float tmpvar_5;
  tmpvar_5 = texture2D (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_4 = tmpvar_5;
  infinite_3 = (depth_4 == 1.0);
  highp vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_6.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_6.z = depth_4;
  highp vec4 tmpvar_7;
  tmpvar_7 = (_ViewProjInv * tmpvar_6);
  highp vec3 tmpvar_8;
  tmpvar_8 = (tmpvar_7 / tmpvar_7.w).xyz;
  worldPos_2 = tmpvar_8;
  highp float tmpvar_9;
  highp vec3 tmpvar_10;
  tmpvar_10 = (tmpvar_8 - _camPos);
  highp float tmpvar_11;
  tmpvar_11 = dot (tmpvar_10, tmpvar_10);
  highp float tmpvar_12;
  tmpvar_12 = (2.0 * dot (tmpvar_10, _camPos));
  highp float tmpvar_13;
  tmpvar_13 = ((tmpvar_12 * tmpvar_12) - ((4.0 * tmpvar_11) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_13 < 0.0)) {
    tmpvar_9 = -1.0;
  } else {
    tmpvar_9 = ((-(tmpvar_12) - sqrt(tmpvar_13)) / (2.0 * tmpvar_11));
  };
  bool tmpvar_14;
  tmpvar_14 = (tmpvar_9 > 0.0);
  if ((!(tmpvar_14) && infinite_3)) {
    tmpvar_1 = vec4(1.0, 1.0, 1.0, 1.0);
  } else {
    highp vec3 tmpvar_15;
    tmpvar_15 = (_camPos + (tmpvar_9 * (tmpvar_8 - _camPos)));
    highp vec3 arg0_16;
    arg0_16 = (tmpvar_15 - _camPos);
    highp vec3 arg0_17;
    arg0_17 = (tmpvar_8 - _camPos);
    bool tmpvar_18;
    tmpvar_18 = (sqrt(dot (arg0_16, arg0_16)) < sqrt(dot (arg0_17, arg0_17)));
    if ((tmpvar_14 && tmpvar_18)) {
      worldPos_2 = tmpvar_15;
    };
    highp float tmpvar_19;
    tmpvar_19 = sqrt(dot (worldPos_2, worldPos_2));
    if ((tmpvar_19 < (Rg + 10.0))) {
      worldPos_2 = ((Rg + 10.0) * normalize(worldPos_2));
    };
    highp vec3 camera_20;
    camera_20 = _camPos;
    highp vec3 _point_21;
    _point_21 = worldPos_2;
    highp vec3 extinction_22;
    highp float mu_23;
    highp float rMu_24;
    highp float r_25;
    highp float d_26;
    extinction_22 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_27;
    tmpvar_27 = (worldPos_2 - _camPos);
    highp float tmpvar_28;
    tmpvar_28 = sqrt(dot (tmpvar_27, tmpvar_27));
    d_26 = tmpvar_28;
    highp float tmpvar_29;
    tmpvar_29 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    highp vec3 tmpvar_30;
    tmpvar_30 = normalize((tmpvar_27 / tmpvar_28));
    highp float tmpvar_31;
    tmpvar_31 = sqrt(dot (_camPos, _camPos));
    r_25 = tmpvar_31;
    if ((tmpvar_31 < (0.9 * Rg))) {
      camera_20.y = (_camPos.y + Rg);
      _point_21.y = (worldPos_2.y + Rg);
      r_25 = sqrt(dot (camera_20, camera_20));
    };
    highp float tmpvar_32;
    tmpvar_32 = dot (camera_20, tmpvar_30);
    rMu_24 = tmpvar_32;
    mu_23 = (tmpvar_32 / r_25);
    highp vec3 tmpvar_33;
    tmpvar_33 = (_point_21 - (tmpvar_30 * clamp (1.0, 0.0, tmpvar_28)));
    _point_21 = tmpvar_33;
    highp float f_34;
    f_34 = (((tmpvar_32 * tmpvar_32) - (r_25 * r_25)) + (tmpvar_29 * tmpvar_29));
    highp float tmpvar_35;
    if ((f_34 >= 0.0)) {
      tmpvar_35 = sqrt(f_34);
    } else {
      tmpvar_35 = 1e+30;
    };
    highp float tmpvar_36;
    tmpvar_36 = max ((-(tmpvar_32) - tmpvar_35), 0.0);
    if (((tmpvar_36 > 0.0) && (tmpvar_36 < tmpvar_28))) {
      camera_20 = (camera_20 + (tmpvar_36 * tmpvar_30));
      highp float tmpvar_37;
      tmpvar_37 = (tmpvar_32 + tmpvar_36);
      rMu_24 = tmpvar_37;
      mu_23 = (tmpvar_37 / tmpvar_29);
      r_25 = tmpvar_29;
      d_26 = (tmpvar_28 - tmpvar_36);
    };
    if ((r_25 < (Rg + 1600.0))) {
      highp float tmpvar_38;
      tmpvar_38 = ((Rg + 1600.0) / r_25);
      r_25 = (r_25 * tmpvar_38);
      rMu_24 = (rMu_24 * tmpvar_38);
      _point_21 = (tmpvar_33 * tmpvar_38);
    };
    highp float tmpvar_39;
    highp vec2 tmpvar_40;
    tmpvar_40.x = mu_23;
    tmpvar_40.y = (mu_23 + (d_26 / r_25));
    highp vec2 tmpvar_41;
    tmpvar_41 = (sqrt(((0.5 / HR) * r_25)) * tmpvar_40);
    highp vec2 tmpvar_42;
    tmpvar_42 = sign(tmpvar_41);
    highp vec2 tmpvar_43;
    tmpvar_43 = (tmpvar_41 * tmpvar_41);
    highp float tmpvar_44;
    if ((tmpvar_42.y > tmpvar_42.x)) {
      tmpvar_44 = exp(tmpvar_43.x);
    } else {
      tmpvar_44 = 0.0;
    };
    highp vec2 tmpvar_45;
    tmpvar_45.x = 1.0;
    tmpvar_45.y = exp(((-(d_26) / HR) * ((d_26 / (2.0 * r_25)) + mu_23)));
    tmpvar_39 = ((sqrt(((6.2831 * HR) * r_25)) * exp(((Rg - r_25) / HR))) * (tmpvar_44 + dot (((tmpvar_42 / ((2.3193 * abs(tmpvar_41)) + sqrt(((1.52 * tmpvar_43) + 4.0)))) * tmpvar_45), vec2(1.0, -1.0))));
    highp vec2 tmpvar_46;
    tmpvar_46.x = mu_23;
    tmpvar_46.y = (mu_23 + (d_26 / r_25));
    highp vec2 tmpvar_47;
    tmpvar_47 = (sqrt(((0.5 / HM) * r_25)) * tmpvar_46);
    highp vec2 tmpvar_48;
    tmpvar_48 = sign(tmpvar_47);
    highp vec2 tmpvar_49;
    tmpvar_49 = (tmpvar_47 * tmpvar_47);
    highp float tmpvar_50;
    if ((tmpvar_48.y > tmpvar_48.x)) {
      tmpvar_50 = exp(tmpvar_49.x);
    } else {
      tmpvar_50 = 0.0;
    };
    highp vec2 tmpvar_51;
    tmpvar_51.x = 1.0;
    tmpvar_51.y = exp(((-(d_26) / HM) * ((d_26 / (2.0 * r_25)) + mu_23)));
    extinction_22 = min (exp(((-(betaR) * tmpvar_39) - (betaMEx * ((sqrt(((6.2831 * HM) * r_25)) * exp(((Rg - r_25) / HM))) * (tmpvar_50 + dot (((tmpvar_48 / ((2.3193 * abs(tmpvar_47)) + sqrt(((1.52 * tmpvar_49) + 4.0)))) * tmpvar_51), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    highp vec4 tmpvar_52;
    tmpvar_52.w = 1.0;
    tmpvar_52.xyz = vec3(mix (1.0, mix ((((extinction_22.x + extinction_22.y) + extinction_22.z) / 3.0), extinction_22.x, _Post_Extinction_Tint), postExtinctionMultiplier));
    tmpvar_1 = tmpvar_52;
  };
  gl_FragData[0] = tmpvar_1;
}



#endif"
}
SubProgram "gles3 " {
"!!GLES3#version 300 es


#ifdef VERTEX

in vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
out highp vec4 xlv_TEXCOORD0;
out highp vec2 xlv_TEXCOORD1;
out highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

out mediump vec4 _glesFragData[4];
uniform highp float HR;
uniform highp vec3 betaR;
uniform highp float HM;
uniform highp vec3 betaMEx;
uniform highp float Rg;
uniform highp float Rt;
uniform highp mat4 _ViewProjInv;
uniform highp float _experimentalAtmoScale;
uniform highp vec3 _camPos;
uniform highp float _Post_Extinction_Tint;
uniform highp float postExtinctionMultiplier;
uniform sampler2D _customDepthTexture;
in highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp vec3 worldPos_2;
  bool infinite_3;
  highp float depth_4;
  lowp float tmpvar_5;
  tmpvar_5 = texture (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_4 = tmpvar_5;
  infinite_3 = (depth_4 == 1.0);
  highp vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_6.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_6.z = depth_4;
  highp vec4 tmpvar_7;
  tmpvar_7 = (_ViewProjInv * tmpvar_6);
  highp vec3 tmpvar_8;
  tmpvar_8 = (tmpvar_7 / tmpvar_7.w).xyz;
  worldPos_2 = tmpvar_8;
  highp float tmpvar_9;
  highp vec3 tmpvar_10;
  tmpvar_10 = (tmpvar_8 - _camPos);
  highp float tmpvar_11;
  tmpvar_11 = dot (tmpvar_10, tmpvar_10);
  highp float tmpvar_12;
  tmpvar_12 = (2.0 * dot (tmpvar_10, _camPos));
  highp float tmpvar_13;
  tmpvar_13 = ((tmpvar_12 * tmpvar_12) - ((4.0 * tmpvar_11) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_13 < 0.0)) {
    tmpvar_9 = -1.0;
  } else {
    tmpvar_9 = ((-(tmpvar_12) - sqrt(tmpvar_13)) / (2.0 * tmpvar_11));
  };
  bool tmpvar_14;
  tmpvar_14 = (tmpvar_9 > 0.0);
  if ((!(tmpvar_14) && infinite_3)) {
    tmpvar_1 = vec4(1.0, 1.0, 1.0, 1.0);
  } else {
    highp vec3 tmpvar_15;
    tmpvar_15 = (_camPos + (tmpvar_9 * (tmpvar_8 - _camPos)));
    highp vec3 arg0_16;
    arg0_16 = (tmpvar_15 - _camPos);
    highp vec3 arg0_17;
    arg0_17 = (tmpvar_8 - _camPos);
    bool tmpvar_18;
    tmpvar_18 = (sqrt(dot (arg0_16, arg0_16)) < sqrt(dot (arg0_17, arg0_17)));
    if ((tmpvar_14 && tmpvar_18)) {
      worldPos_2 = tmpvar_15;
    };
    highp float tmpvar_19;
    tmpvar_19 = sqrt(dot (worldPos_2, worldPos_2));
    if ((tmpvar_19 < (Rg + 10.0))) {
      worldPos_2 = ((Rg + 10.0) * normalize(worldPos_2));
    };
    highp vec3 camera_20;
    camera_20 = _camPos;
    highp vec3 _point_21;
    _point_21 = worldPos_2;
    highp vec3 extinction_22;
    highp float mu_23;
    highp float rMu_24;
    highp float r_25;
    highp float d_26;
    extinction_22 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_27;
    tmpvar_27 = (worldPos_2 - _camPos);
    highp float tmpvar_28;
    tmpvar_28 = sqrt(dot (tmpvar_27, tmpvar_27));
    d_26 = tmpvar_28;
    highp float tmpvar_29;
    tmpvar_29 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    highp vec3 tmpvar_30;
    tmpvar_30 = normalize((tmpvar_27 / tmpvar_28));
    highp float tmpvar_31;
    tmpvar_31 = sqrt(dot (_camPos, _camPos));
    r_25 = tmpvar_31;
    if ((tmpvar_31 < (0.9 * Rg))) {
      camera_20.y = (_camPos.y + Rg);
      _point_21.y = (worldPos_2.y + Rg);
      r_25 = sqrt(dot (camera_20, camera_20));
    };
    highp float tmpvar_32;
    tmpvar_32 = dot (camera_20, tmpvar_30);
    rMu_24 = tmpvar_32;
    mu_23 = (tmpvar_32 / r_25);
    highp vec3 tmpvar_33;
    tmpvar_33 = (_point_21 - (tmpvar_30 * clamp (1.0, 0.0, tmpvar_28)));
    _point_21 = tmpvar_33;
    highp float f_34;
    f_34 = (((tmpvar_32 * tmpvar_32) - (r_25 * r_25)) + (tmpvar_29 * tmpvar_29));
    highp float tmpvar_35;
    if ((f_34 >= 0.0)) {
      tmpvar_35 = sqrt(f_34);
    } else {
      tmpvar_35 = 1e+30;
    };
    highp float tmpvar_36;
    tmpvar_36 = max ((-(tmpvar_32) - tmpvar_35), 0.0);
    if (((tmpvar_36 > 0.0) && (tmpvar_36 < tmpvar_28))) {
      camera_20 = (camera_20 + (tmpvar_36 * tmpvar_30));
      highp float tmpvar_37;
      tmpvar_37 = (tmpvar_32 + tmpvar_36);
      rMu_24 = tmpvar_37;
      mu_23 = (tmpvar_37 / tmpvar_29);
      r_25 = tmpvar_29;
      d_26 = (tmpvar_28 - tmpvar_36);
    };
    if ((r_25 < (Rg + 1600.0))) {
      highp float tmpvar_38;
      tmpvar_38 = ((Rg + 1600.0) / r_25);
      r_25 = (r_25 * tmpvar_38);
      rMu_24 = (rMu_24 * tmpvar_38);
      _point_21 = (tmpvar_33 * tmpvar_38);
    };
    highp float tmpvar_39;
    highp vec2 tmpvar_40;
    tmpvar_40.x = mu_23;
    tmpvar_40.y = (mu_23 + (d_26 / r_25));
    highp vec2 tmpvar_41;
    tmpvar_41 = (sqrt(((0.5 / HR) * r_25)) * tmpvar_40);
    highp vec2 tmpvar_42;
    tmpvar_42 = sign(tmpvar_41);
    highp vec2 tmpvar_43;
    tmpvar_43 = (tmpvar_41 * tmpvar_41);
    highp float tmpvar_44;
    if ((tmpvar_42.y > tmpvar_42.x)) {
      tmpvar_44 = exp(tmpvar_43.x);
    } else {
      tmpvar_44 = 0.0;
    };
    highp vec2 tmpvar_45;
    tmpvar_45.x = 1.0;
    tmpvar_45.y = exp(((-(d_26) / HR) * ((d_26 / (2.0 * r_25)) + mu_23)));
    tmpvar_39 = ((sqrt(((6.2831 * HR) * r_25)) * exp(((Rg - r_25) / HR))) * (tmpvar_44 + dot (((tmpvar_42 / ((2.3193 * abs(tmpvar_41)) + sqrt(((1.52 * tmpvar_43) + 4.0)))) * tmpvar_45), vec2(1.0, -1.0))));
    highp vec2 tmpvar_46;
    tmpvar_46.x = mu_23;
    tmpvar_46.y = (mu_23 + (d_26 / r_25));
    highp vec2 tmpvar_47;
    tmpvar_47 = (sqrt(((0.5 / HM) * r_25)) * tmpvar_46);
    highp vec2 tmpvar_48;
    tmpvar_48 = sign(tmpvar_47);
    highp vec2 tmpvar_49;
    tmpvar_49 = (tmpvar_47 * tmpvar_47);
    highp float tmpvar_50;
    if ((tmpvar_48.y > tmpvar_48.x)) {
      tmpvar_50 = exp(tmpvar_49.x);
    } else {
      tmpvar_50 = 0.0;
    };
    highp vec2 tmpvar_51;
    tmpvar_51.x = 1.0;
    tmpvar_51.y = exp(((-(d_26) / HM) * ((d_26 / (2.0 * r_25)) + mu_23)));
    extinction_22 = min (exp(((-(betaR) * tmpvar_39) - (betaMEx * ((sqrt(((6.2831 * HM) * r_25)) * exp(((Rg - r_25) / HM))) * (tmpvar_50 + dot (((tmpvar_48 / ((2.3193 * abs(tmpvar_47)) + sqrt(((1.52 * tmpvar_49) + 4.0)))) * tmpvar_51), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    highp vec4 tmpvar_52;
    tmpvar_52.w = 1.0;
    tmpvar_52.xyz = vec3(mix (1.0, mix ((((extinction_22.x + extinction_22.y) + extinction_22.z) / 3.0), extinction_22.x, _Post_Extinction_Tint), postExtinctionMultiplier));
    tmpvar_1 = tmpvar_52;
  };
  _glesFragData[0] = tmpvar_1;
}



#endif"
}
}
Program "fp" {
SubProgram "opengl " {
"!!GLSL"
}
SubProgram "d3d9 " {
// Stats: 236 math, 1 textures, 1 branches
Matrix 0 [_ViewProjInv]
Float 4 [HR]
Vector 5 [betaR]
Float 6 [HM]
Vector 7 [betaMEx]
Float 8 [Rg]
Float 9 [Rt]
Float 10 [_experimentalAtmoScale]
Vector 11 [_camPos]
Float 12 [_Post_Extinction_Tint]
Float 13 [postExtinctionMultiplier]
SetTexture 0 [_customDepthTexture] 2D 0
"ps_3_0
dcl_2d s0
def c14, 2.00000000, -1.00000000, 1.00000000, 0.00000000
def c15, 4.00000000, 0.89999998, -10.00000000, 10.00000000
def c16, 1000000015047466200000000000000.00000000, -1600.00000000, 1600.00000000, 6.28310013
def c17, 2.71828198, 0.50000000, 2.31929994, 0.33333334
def c18, 1.51999998, 4.00000000, 0, 0
dcl_texcoord2 v0.xy
texld r2.x, v0, s0
mov r3.z, r2.x
mad r3.xy, v0, c14.x, c14.y
mov r3.w, c14.z
dp4 r2.y, r3, c3
dp4 r0.z, r3, c2
dp4 r0.y, r3, c1
dp4 r0.x, r3, c0
rcp r2.y, r2.y
mul r0.xyz, r0, r2.y
mov r3.xyz, c11
dp3 r2.z, c14.w, r3
dp3 r2.y, c11, c11
add r2.y, r2, -r2.z
add r3.xyz, r0, -c11
mad r2.z, -c8.x, c8.x, r2.y
dp3 r2.y, r3, r3
mul r2.w, r2.y, r2.z
dp3 r2.z, r3, c11
mul r2.w, r2, c15.x
mul r2.z, r2, c14.x
mad r3.x, r2.z, r2.z, -r2.w
cmp_pp r2.w, r3.x, c14.z, c14
cmp r0.w, r3.x, r0, c14.y
rsq r3.x, r3.x
mul r3.y, r2, c14.x
rcp r2.y, r3.x
add r2.x, r2, c14.y
rcp r3.x, r3.y
add r2.y, -r2.z, -r2
mul r2.y, r2, r3.x
cmp r0.w, -r2, r0, r2.y
abs r2.y, r2.x
cmp r2.w, -r0, c14, c14.z
abs_pp r2.x, r2.w
cmp r2.y, -r2, c14.z, c14.w
cmp_pp r2.x, -r2, c14.z, c14.w
mul_pp r2.x, r2, r2.y
cmp_pp r2.y, -r2.x, c14.z, c14.w
cmp_pp oC0, -r2.x, r1, c14.z
if_gt r2.y, c14.w
add r2.xyz, r0, -c11
dp3 r1.w, r2, r2
mul r1.xyz, r0.w, r2
dp3 r0.w, r1, r1
rsq r1.w, r1.w
rsq r0.w, r0.w
rcp r3.z, c6.x
rcp r1.w, r1.w
rcp r0.w, r0.w
add r0.w, r0, -r1
cmp r0.w, r0, c14, c14.z
mul_pp r0.w, r2, r0
add r1.xyz, r1, c11
cmp r0.xyz, -r0.w, r0, r1
dp3 r0.w, r0, r0
rsq r0.w, r0.w
rcp r1.w, r0.w
mul r1.xyz, r0.w, r0
mov r0.w, c8.x
add r0.w, c15, r0
mul r1.xyz, r0.w, r1
add r1.w, r1, -c8.x
add r0.w, r1, c15.z
cmp r0.xyz, r0.w, r0, r1
add r0.xyz, r0, -c11
dp3 r0.w, r0, r0
rsq r0.w, r0.w
mul r1.xyz, r0.w, r0
dp3 r0.x, r1, r1
rsq r2.z, r0.x
mov r0.y, c11
add r2.y, c8.x, r0
dp3 r1.w, c11, c11
rsq r1.w, r1.w
mul r1.xyz, r2.z, r1
rcp r0.w, r0.w
mov r0.xz, c11
rcp r1.w, r1.w
mov r0.y, c8.x
mad r2.x, c15.y, -r0.y, r1.w
cmp r0.y, r2.x, c11, r2
dp3 r2.y, r0, r0
dp3 r0.x, r0, r1
rsq r2.y, r2.y
rcp r0.y, r2.y
cmp r0.y, r2.x, r1.w, r0
mul r1.x, r0.y, r0.y
mov r0.z, c9.x
add r0.z, -c8.x, r0
mul r0.z, r0, c10.x
add r0.z, r0, c8.x
mad r1.x, r0, r0, -r1
mad r1.x, r0.z, r0.z, r1
rsq r1.y, r1.x
rcp r1.y, r1.y
cmp r1.x, r1, r1.y, c16
add r1.x, -r0, -r1
max r1.x, r1, c14.w
add r1.y, r1.x, -r0.w
cmp r1.z, r1.y, c14.w, c14
cmp r1.y, -r1.x, c14.w, c14.z
mul_pp r1.y, r1, r1.z
cmp r1.w, -r1.y, r0.y, r0.z
add r2.x, r1.w, -c8
mov r1.z, c8.x
add r2.x, r2, c16.y
add r1.z, c16, r1
cmp r3.x, r2, r1.w, r1.z
add r2.x, -r1, r0.w
mul r1.z, r3.x, r3
mul r1.z, r1, c17.y
rsq r1.z, r1.z
add r1.x, r1, r0
rcp r0.y, r0.y
rcp r0.z, r0.z
mul r0.z, r1.x, r0
mul r0.x, r0, r0.y
cmp r0.x, -r1.y, r0, r0.z
cmp r0.z, -r1.y, r0.w, r2.x
rcp r1.w, r3.x
mad r0.y, r0.z, r1.w, r0.x
rcp r1.z, r1.z
mul r1.zw, r0.xyxy, r1.z
mul r3.yw, r1.xzzw, r1.xzzw
cmp r1.xy, -r1.zwzw, c14.w, c14.z
cmp r2.xy, r1.zwzw, c14.w, c14.z
add r2.xy, r1, -r2
mad r1.xy, r3.ywzw, c18.x, c18.y
rsq r0.w, r1.x
rcp r1.x, r0.w
rsq r1.y, r1.y
mul r0.w, r3.x, c14.x
rcp r0.w, r0.w
mad r0.w, r0.z, r0, r0.x
abs r1.zw, r1
rcp r1.y, r1.y
mad r2.zw, r1, c17.z, r1.xyxy
mul r1.x, -r0.z, r3.z
mul r3.w, r0, r1.x
pow r1, c17.x, r3.w
rcp r2.z, r2.z
rcp r2.w, r2.w
mul r1.zw, r2.xyxy, r2
mov r1.x, c14.z
mul r1.xy, r1.zwzw, r1
mul r2.zw, r1.xyxy, c14.xyzy
pow r1, c17.x, r3.y
add r1.z, r2, r2.w
rcp r1.w, c4.x
add r1.y, r2, -r2.x
cmp r1.x, -r1.y, c14.w, r1
add r1.x, r1, r1.z
mul r1.y, r3.x, r1.w
add r3.y, -r3.x, c8.x
mul r3.z, r3.y, r3
pow r2, c17.x, r3.z
mul r1.y, r1, c17
rsq r1.y, r1.y
mul r1.z, r3.x, c6.x
mul r1.z, r1, c16.w
rsq r1.z, r1.z
rcp r1.y, r1.y
mul r2.zw, r1.y, r0.xyxy
rcp r1.z, r1.z
mul r1.z, r1, r2.x
mul r1.x, r1.z, r1
mul r3.zw, r2, r2
cmp r0.xy, -r2.zwzw, c14.w, c14.z
cmp r2.xy, r2.zwzw, c14.w, c14.z
add r2.xy, r0, -r2
mad r0.xy, r3.zwzw, c18.x, c18.y
mul r0.z, r1.w, -r0
rsq r0.x, r0.x
rsq r0.y, r0.y
mul r1.xyz, r1.x, c7
rcp r0.x, r0.x
rcp r0.y, r0.y
abs r2.zw, r2
mad r2.zw, r2, c17.z, r0.xyxy
mul r3.w, r0.z, r0
pow r0, c17.x, r3.w
rcp r2.z, r2.z
rcp r2.w, r2.w
mul r0.zw, r2.xyxy, r2
mov r0.x, c14.z
mul r2.zw, r0, r0.xyxy
pow r0, c17.x, r3.z
mul r0.zw, r2, c14.xyzy
mov r0.y, r0.x
add r0.x, r2.y, -r2
mul r2.y, r3, r1.w
add r0.z, r0, r0.w
cmp r0.x, -r0, c14.w, r0.y
add r2.x, r0, r0.z
pow r0, c17.x, r2.y
mul r1.w, r3.x, c4.x
mul r0.y, r1.w, c16.w
mov r0.z, r0.x
rsq r0.y, r0.y
rcp r0.x, r0.y
mul r0.x, r0, r0.z
mul r0.x, r0, r2
mad r2.xyz, r0.x, -c5, -r1
pow r0, c17.x, r2.x
mov r2.x, r0
pow r0, c17.x, r2.y
pow r1, c17.x, r2.z
mov r2.z, r1
mov r2.y, r0
min r0.xyz, r2, c14.z
add r0.y, r0.x, r0
add r0.y, r0, r0.z
mul r0.z, r0.y, c17.w
mad r0.x, -r0.y, c17.w, r0
mad r0.x, r0, c12, r0.z
add r0.x, r0, c14.y
mul r0.x, r0, c13
add oC0.xyz, r0.x, c14.z
mov oC0.w, c14.z
endif
"
}
SubProgram "d3d11 " {
// Stats: 149 math, 1 textures, 2 branches
SetTexture 0 [_customDepthTexture] 2D 0
ConstBuffer "$Globals" 400
Matrix 160 [_ViewProjInv]
Float 52 [HR]
Vector 64 [betaR] 3
Float 76 [HM]
Vector 96 [betaMEx] 3
Float 112 [Rg]
Float 116 [Rt]
Float 228 [_experimentalAtmoScale]
Vector 272 [_camPos] 3
Float 284 [_Post_Extinction_Tint]
Float 288 [postExtinctionMultiplier]
BindCB  "$Globals" 0
"ps_4_0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"
}
SubProgram "gles " {
"!!GLES"
}
SubProgram "glesdesktop " {
"!!GLES"
}
SubProgram "gles3 " {
"!!GLES3"
}
}
 }


 // Stats for Vertex shader:
 //       d3d11 : 15 math
 //        d3d9 : 20 math, 1 branch
 // Stats for Fragment shader:
 //       d3d11 : 360 math, 2 texture, 2 branch
 //        d3d9 : 535 math, 18 texture, 1 branch
 Pass {
  Tags { "QUEUE"="Transparent-5" "IgnoreProjector"="True" "RenderType"="Transparent" }
  ZWrite Off
  Cull Front
  Fog { Mode Off }
  Blend OneMinusDstColor One
Program "vp" {
SubProgram "opengl " {
"!!GLSL
#ifdef VERTEX
uniform vec4 _ProjectionParams;


varying vec4 xlv_TEXCOORD0;
varying vec2 xlv_TEXCOORD1;
varying vec2 xlv_TEXCOORD2;
void main ()
{
  vec4 tmpvar_1;
  vec4 tmpvar_2;
  tmpvar_2 = (gl_ModelViewProjectionMatrix * gl_Vertex);
  vec4 o_3;
  vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((gl_ModelViewMatrix * gl_Vertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}


#endif
#ifdef FRAGMENT
#extension GL_ARB_shader_texture_lod : enable
uniform sampler2D _Inscatter;
uniform float M_PI;
uniform float HR;
uniform vec3 betaR;
uniform float HM;
uniform vec3 betaMEx;
uniform float mieG;
uniform float Rg;
uniform float Rt;
uniform float RES_R;
uniform float RES_MU;
uniform float RES_MU_S;
uniform float RES_NU;
uniform vec3 SUN_DIR;
uniform float SUN_INTENSITY;
uniform mat4 _ViewProjInv;
uniform float _experimentalAtmoScale;
uniform float _global_alpha;
uniform float _Exposure;
uniform float _global_depth;
uniform vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform sampler2D _godrayDepthTexture;
uniform float _openglThreshold;
varying vec2 xlv_TEXCOORD2;
void main ()
{
  vec4 tmpvar_1;
  bool infinite_2;
  float depth_3;
  vec4 tmpvar_4;
  tmpvar_4 = texture2D (_customDepthTexture, xlv_TEXCOORD2);
  float tmpvar_5;
  tmpvar_5 = tmpvar_4.x;
  depth_3 = tmpvar_5;
  infinite_2 = (tmpvar_4.x == 1.0);
  vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_6.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_6.z = tmpvar_5;
  vec4 tmpvar_7;
  tmpvar_7 = (_ViewProjInv * tmpvar_6);
  float tmpvar_8;
  tmpvar_8 = (1.0 - abs(dot (normalize(((_camPos.yzx * SUN_DIR.zxy) - (_camPos.zxy * SUN_DIR.yzx))), normalize(((tmpvar_7 / tmpvar_7.w).xyz - _camPos)))));
  vec4 tmpvar_9;
  tmpvar_9 = texture2D (_godrayDepthTexture, xlv_TEXCOORD2);
  if ((((tmpvar_9.x > 0.0) && (tmpvar_9.x < tmpvar_4.x)) && (tmpvar_4.x < 1.0))) {
    depth_3 = mix (tmpvar_4.x, tmpvar_9.x, tmpvar_8);
  };
  vec4 tmpvar_10;
  tmpvar_10.w = 1.0;
  tmpvar_10.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_10.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_10.z = depth_3;
  vec4 tmpvar_11;
  tmpvar_11 = (_ViewProjInv * tmpvar_10);
  vec3 tmpvar_12;
  tmpvar_12 = (tmpvar_11 / tmpvar_11.w).xyz;
  float tmpvar_13;
  vec3 tmpvar_14;
  tmpvar_14 = (tmpvar_12 - _camPos);
  float tmpvar_15;
  tmpvar_15 = dot (tmpvar_14, tmpvar_14);
  float tmpvar_16;
  tmpvar_16 = (2.0 * dot (tmpvar_14, _camPos));
  float tmpvar_17;
  tmpvar_17 = ((tmpvar_16 * tmpvar_16) - ((4.0 * tmpvar_15) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_17 < 0.0)) {
    tmpvar_13 = -1.0;
  } else {
    tmpvar_13 = ((-(tmpvar_16) - sqrt(tmpvar_17)) / (2.0 * tmpvar_15));
  };
  bool tmpvar_18;
  tmpvar_18 = (tmpvar_13 > 0.0);
  if ((!(tmpvar_18) && infinite_2)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    vec3 tmpvar_19;
    tmpvar_19 = (_camPos + (tmpvar_13 * (tmpvar_12 - _camPos)));
    vec3 arg0_20;
    arg0_20 = (tmpvar_19 - _camPos);
    vec3 arg0_21;
    arg0_21 = (tmpvar_12 - _camPos);
    bool tmpvar_22;
    tmpvar_22 = (sqrt(dot (arg0_20, arg0_20)) < sqrt(dot (arg0_21, arg0_21)));
    vec3 tmpvar_23;
    if ((tmpvar_18 && tmpvar_22)) {
      tmpvar_23 = tmpvar_19;
    } else {
      tmpvar_23 = tmpvar_12;
    };
    float tmpvar_24;
    tmpvar_24 = sqrt(dot (tmpvar_23, tmpvar_23));
    vec3 tmpvar_25;
    if ((tmpvar_24 < (Rg + _openglThreshold))) {
      tmpvar_25 = ((Rg + _openglThreshold) * normalize(tmpvar_23));
    } else {
      tmpvar_25 = tmpvar_23;
    };
    vec3 tmpvar_26;
    vec3 camera_27;
    camera_27 = _camPos;
    vec3 _point_28;
    _point_28 = tmpvar_25;
    vec3 extinction_29;
    vec4 inScatter0_30;
    float muS1_31;
    float mu1_32;
    vec4 inScatter_33;
    float mu_34;
    float rMu_35;
    float r_36;
    float d_37;
    extinction_29 = vec3(1.0, 1.0, 1.0);
    vec3 tmpvar_38;
    tmpvar_38 = (tmpvar_25 - _camPos);
    float tmpvar_39;
    tmpvar_39 = sqrt(dot (tmpvar_38, tmpvar_38));
    d_37 = tmpvar_39;
    float tmpvar_40;
    tmpvar_40 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    vec3 tmpvar_41;
    tmpvar_41 = normalize((tmpvar_38 / tmpvar_39));
    float tmpvar_42;
    tmpvar_42 = sqrt(dot (_camPos, _camPos));
    r_36 = tmpvar_42;
    if ((tmpvar_42 < (0.9 * Rg))) {
      camera_27.y = (_camPos.y + Rg);
      _point_28.y = (tmpvar_25.y + Rg);
      r_36 = sqrt(dot (camera_27, camera_27));
    };
    float tmpvar_43;
    tmpvar_43 = dot (camera_27, tmpvar_41);
    rMu_35 = tmpvar_43;
    mu_34 = (tmpvar_43 / r_36);
    vec3 tmpvar_44;
    tmpvar_44 = (_point_28 - (tmpvar_41 * clamp (1.0, 0.0, tmpvar_39)));
    _point_28 = tmpvar_44;
    float f_45;
    f_45 = (((tmpvar_43 * tmpvar_43) - (r_36 * r_36)) + (tmpvar_40 * tmpvar_40));
    float tmpvar_46;
    if ((f_45 >= 0.0)) {
      tmpvar_46 = sqrt(f_45);
    } else {
      tmpvar_46 = 1e+30;
    };
    float tmpvar_47;
    tmpvar_47 = max ((-(tmpvar_43) - tmpvar_46), 0.0);
    if (((tmpvar_47 > 0.0) && (tmpvar_47 < tmpvar_39))) {
      camera_27 = (camera_27 + (tmpvar_47 * tmpvar_41));
      float tmpvar_48;
      tmpvar_48 = (tmpvar_43 + tmpvar_47);
      rMu_35 = tmpvar_48;
      mu_34 = (tmpvar_48 / tmpvar_40);
      r_36 = tmpvar_40;
      d_37 = (tmpvar_39 - tmpvar_47);
    };
    float tmpvar_49;
    tmpvar_49 = dot (tmpvar_41, SUN_DIR);
    float tmpvar_50;
    tmpvar_50 = (dot (camera_27, SUN_DIR) / r_36);
    if ((r_36 < (Rg + 1600.0))) {
      float tmpvar_51;
      tmpvar_51 = ((Rg + 1600.0) / r_36);
      r_36 = (r_36 * tmpvar_51);
      rMu_35 = (rMu_35 * tmpvar_51);
      _point_28 = (tmpvar_44 * tmpvar_51);
    };
    float tmpvar_52;
    tmpvar_52 = sqrt(dot (_point_28, _point_28));
    mu1_32 = (dot (_point_28, tmpvar_41) / tmpvar_52);
    muS1_31 = (dot (_point_28, SUN_DIR) / tmpvar_52);
    float tmpvar_53;
    vec2 tmpvar_54;
    tmpvar_54.x = mu_34;
    tmpvar_54.y = (mu_34 + (d_37 / r_36));
    vec2 tmpvar_55;
    tmpvar_55 = (sqrt(((0.5 / HR) * r_36)) * tmpvar_54);
    vec2 tmpvar_56;
    tmpvar_56 = sign(tmpvar_55);
    vec2 tmpvar_57;
    tmpvar_57 = (tmpvar_55 * tmpvar_55);
    float tmpvar_58;
    if ((tmpvar_56.y > tmpvar_56.x)) {
      tmpvar_58 = exp(tmpvar_57.x);
    } else {
      tmpvar_58 = 0.0;
    };
    vec2 tmpvar_59;
    tmpvar_59.x = 1.0;
    tmpvar_59.y = exp(((-(d_37) / HR) * ((d_37 / (2.0 * r_36)) + mu_34)));
    tmpvar_53 = ((sqrt(((6.2831 * HR) * r_36)) * exp(((Rg - r_36) / HR))) * (tmpvar_58 + dot (((tmpvar_56 / ((2.3193 * abs(tmpvar_55)) + sqrt(((1.52 * tmpvar_57) + 4.0)))) * tmpvar_59), vec2(1.0, -1.0))));
    vec2 tmpvar_60;
    tmpvar_60.x = mu_34;
    tmpvar_60.y = (mu_34 + (d_37 / r_36));
    vec2 tmpvar_61;
    tmpvar_61 = (sqrt(((0.5 / HM) * r_36)) * tmpvar_60);
    vec2 tmpvar_62;
    tmpvar_62 = sign(tmpvar_61);
    vec2 tmpvar_63;
    tmpvar_63 = (tmpvar_61 * tmpvar_61);
    float tmpvar_64;
    if ((tmpvar_62.y > tmpvar_62.x)) {
      tmpvar_64 = exp(tmpvar_63.x);
    } else {
      tmpvar_64 = 0.0;
    };
    vec2 tmpvar_65;
    tmpvar_65.x = 1.0;
    tmpvar_65.y = exp(((-(d_37) / HM) * ((d_37 / (2.0 * r_36)) + mu_34)));
    extinction_29 = min (exp(((-(betaR) * tmpvar_53) - (betaMEx * ((sqrt(((6.2831 * HM) * r_36)) * exp(((Rg - r_36) / HM))) * (tmpvar_64 + dot (((tmpvar_62 / ((2.3193 * abs(tmpvar_61)) + sqrt(((1.52 * tmpvar_63) + 4.0)))) * tmpvar_65), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    float uMu_66;
    float uR_67;
    float tmpvar_68;
    tmpvar_68 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    float tmpvar_69;
    tmpvar_69 = sqrt(((r_36 * r_36) - (Rg * Rg)));
    float tmpvar_70;
    tmpvar_70 = (r_36 * mu_34);
    float tmpvar_71;
    tmpvar_71 = (((tmpvar_70 * tmpvar_70) - (r_36 * r_36)) + (Rg * Rg));
    vec4 tmpvar_72;
    if (((tmpvar_70 < 0.0) && (tmpvar_71 > 0.0))) {
      vec4 tmpvar_73;
      tmpvar_73.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_73.w = (0.5 - (0.5 / RES_MU));
      tmpvar_72 = tmpvar_73;
    } else {
      vec4 tmpvar_74;
      tmpvar_74.x = -1.0;
      tmpvar_74.y = (tmpvar_68 * tmpvar_68);
      tmpvar_74.z = tmpvar_68;
      tmpvar_74.w = (0.5 + (0.5 / RES_MU));
      tmpvar_72 = tmpvar_74;
    };
    uR_67 = ((0.5 / RES_R) + ((tmpvar_69 / tmpvar_68) * (1.0 - (1.0/(RES_R)))));
    uMu_66 = (tmpvar_72.w + ((((tmpvar_70 * tmpvar_72.x) + sqrt((tmpvar_71 + tmpvar_72.y))) / (tmpvar_69 + tmpvar_72.z)) * (0.5 - (1.0/(RES_MU)))));
    float y_over_x_75;
    y_over_x_75 = (max (tmpvar_50, -0.1975) * 5.34962);
    float x_76;
    x_76 = (y_over_x_75 * inversesqrt(((y_over_x_75 * y_over_x_75) + 1.0)));
    float tmpvar_77;
    tmpvar_77 = ((0.5 / RES_MU_S) + (((((sign(x_76) * (1.5708 - (sqrt((1.0 - abs(x_76))) * (1.5708 + (abs(x_76) * (-0.214602 + (abs(x_76) * (0.0865667 + (abs(x_76) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    float tmpvar_78;
    tmpvar_78 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    float tmpvar_79;
    tmpvar_79 = floor(tmpvar_78);
    float tmpvar_80;
    tmpvar_80 = (tmpvar_78 - tmpvar_79);
    float tmpvar_81;
    tmpvar_81 = (floor(((uR_67 * RES_R) - 1.0)) / RES_R);
    float tmpvar_82;
    tmpvar_82 = (floor((uR_67 * RES_R)) / RES_R);
    float tmpvar_83;
    tmpvar_83 = fract((uR_67 * RES_R));
    vec4 tmpvar_84;
    tmpvar_84.zw = vec2(0.0, 0.0);
    tmpvar_84.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_84.y = ((uMu_66 / RES_R) + tmpvar_81);
    vec4 tmpvar_85;
    tmpvar_85.zw = vec2(0.0, 0.0);
    tmpvar_85.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_85.y = ((uMu_66 / RES_R) + tmpvar_81);
    vec4 tmpvar_86;
    tmpvar_86.zw = vec2(0.0, 0.0);
    tmpvar_86.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_86.y = ((uMu_66 / RES_R) + tmpvar_82);
    vec4 tmpvar_87;
    tmpvar_87.zw = vec2(0.0, 0.0);
    tmpvar_87.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_87.y = ((uMu_66 / RES_R) + tmpvar_82);
    inScatter0_30 = ((((texture2DLod (_Inscatter, tmpvar_84.xy, 0.0) * (1.0 - tmpvar_80)) + (texture2DLod (_Inscatter, tmpvar_85.xy, 0.0) * tmpvar_80)) * (1.0 - tmpvar_83)) + (((texture2DLod (_Inscatter, tmpvar_86.xy, 0.0) * (1.0 - tmpvar_80)) + (texture2DLod (_Inscatter, tmpvar_87.xy, 0.0) * tmpvar_80)) * tmpvar_83));
    float uMu_88;
    float uR_89;
    float tmpvar_90;
    tmpvar_90 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    float tmpvar_91;
    tmpvar_91 = sqrt(((tmpvar_52 * tmpvar_52) - (Rg * Rg)));
    float tmpvar_92;
    tmpvar_92 = (tmpvar_52 * mu1_32);
    float tmpvar_93;
    tmpvar_93 = (((tmpvar_92 * tmpvar_92) - (tmpvar_52 * tmpvar_52)) + (Rg * Rg));
    vec4 tmpvar_94;
    if (((tmpvar_92 < 0.0) && (tmpvar_93 > 0.0))) {
      vec4 tmpvar_95;
      tmpvar_95.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_95.w = (0.5 - (0.5 / RES_MU));
      tmpvar_94 = tmpvar_95;
    } else {
      vec4 tmpvar_96;
      tmpvar_96.x = -1.0;
      tmpvar_96.y = (tmpvar_90 * tmpvar_90);
      tmpvar_96.z = tmpvar_90;
      tmpvar_96.w = (0.5 + (0.5 / RES_MU));
      tmpvar_94 = tmpvar_96;
    };
    uR_89 = ((0.5 / RES_R) + ((tmpvar_91 / tmpvar_90) * (1.0 - (1.0/(RES_R)))));
    uMu_88 = (tmpvar_94.w + ((((tmpvar_92 * tmpvar_94.x) + sqrt((tmpvar_93 + tmpvar_94.y))) / (tmpvar_91 + tmpvar_94.z)) * (0.5 - (1.0/(RES_MU)))));
    float y_over_x_97;
    y_over_x_97 = (max (muS1_31, -0.1975) * 5.34962);
    float x_98;
    x_98 = (y_over_x_97 * inversesqrt(((y_over_x_97 * y_over_x_97) + 1.0)));
    float tmpvar_99;
    tmpvar_99 = ((0.5 / RES_MU_S) + (((((sign(x_98) * (1.5708 - (sqrt((1.0 - abs(x_98))) * (1.5708 + (abs(x_98) * (-0.214602 + (abs(x_98) * (0.0865667 + (abs(x_98) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    float tmpvar_100;
    tmpvar_100 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    float tmpvar_101;
    tmpvar_101 = floor(tmpvar_100);
    float tmpvar_102;
    tmpvar_102 = (tmpvar_100 - tmpvar_101);
    float tmpvar_103;
    tmpvar_103 = (floor(((uR_89 * RES_R) - 1.0)) / RES_R);
    float tmpvar_104;
    tmpvar_104 = (floor((uR_89 * RES_R)) / RES_R);
    float tmpvar_105;
    tmpvar_105 = fract((uR_89 * RES_R));
    vec4 tmpvar_106;
    tmpvar_106.zw = vec2(0.0, 0.0);
    tmpvar_106.x = ((tmpvar_101 + tmpvar_99) / RES_NU);
    tmpvar_106.y = ((uMu_88 / RES_R) + tmpvar_103);
    vec4 tmpvar_107;
    tmpvar_107.zw = vec2(0.0, 0.0);
    tmpvar_107.x = (((tmpvar_101 + tmpvar_99) + 1.0) / RES_NU);
    tmpvar_107.y = ((uMu_88 / RES_R) + tmpvar_103);
    vec4 tmpvar_108;
    tmpvar_108.zw = vec2(0.0, 0.0);
    tmpvar_108.x = ((tmpvar_101 + tmpvar_99) / RES_NU);
    tmpvar_108.y = ((uMu_88 / RES_R) + tmpvar_104);
    vec4 tmpvar_109;
    tmpvar_109.zw = vec2(0.0, 0.0);
    tmpvar_109.x = (((tmpvar_101 + tmpvar_99) + 1.0) / RES_NU);
    tmpvar_109.y = ((uMu_88 / RES_R) + tmpvar_104);
    vec4 tmpvar_110;
    tmpvar_110 = max ((inScatter0_30 - (((((texture2DLod (_Inscatter, tmpvar_106.xy, 0.0) * (1.0 - tmpvar_102)) + (texture2DLod (_Inscatter, tmpvar_107.xy, 0.0) * tmpvar_102)) * (1.0 - tmpvar_105)) + (((texture2DLod (_Inscatter, tmpvar_108.xy, 0.0) * (1.0 - tmpvar_102)) + (texture2DLod (_Inscatter, tmpvar_109.xy, 0.0) * tmpvar_102)) * tmpvar_105)) * extinction_29.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
    inScatter_33.xyz = tmpvar_110.xyz;
    float t_111;
    t_111 = max (min ((tmpvar_50 / 0.02), 1.0), 0.0);
    inScatter_33.w = (tmpvar_110.w * (t_111 * (t_111 * (3.0 - (2.0 * t_111)))));
    tmpvar_26 = (((tmpvar_110.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_49 * tmpvar_49)))) + ((((tmpvar_110.xyz * inScatter_33.w) / max (tmpvar_110.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_49)), -1.5)) * (1.0 + (tmpvar_49 * tmpvar_49))) / (2.0 + (mieG * mieG))))) * SUN_INTENSITY);
    float tmpvar_112;
    vec3 arg0_113;
    arg0_113 = (tmpvar_25 - _camPos);
    tmpvar_112 = sqrt(dot (arg0_113, arg0_113));
    float tmpvar_114;
    if ((tmpvar_112 <= _global_depth)) {
      tmpvar_114 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_112) / _global_depth))));
    } else {
      tmpvar_114 = 1.0;
    };
    vec3 L_115;
    vec3 tmpvar_116;
    tmpvar_116 = (tmpvar_26 * _Exposure);
    L_115 = tmpvar_116;
    float tmpvar_117;
    if ((tmpvar_116.x < 1.413)) {
      tmpvar_117 = pow ((tmpvar_116.x * 0.38317), 0.454545);
    } else {
      tmpvar_117 = (1.0 - exp(-(tmpvar_116.x)));
    };
    L_115.x = tmpvar_117;
    float tmpvar_118;
    if ((tmpvar_116.y < 1.413)) {
      tmpvar_118 = pow ((tmpvar_116.y * 0.38317), 0.454545);
    } else {
      tmpvar_118 = (1.0 - exp(-(tmpvar_116.y)));
    };
    L_115.y = tmpvar_118;
    float tmpvar_119;
    if ((tmpvar_116.z < 1.413)) {
      tmpvar_119 = pow ((tmpvar_116.z * 0.38317), 0.454545);
    } else {
      tmpvar_119 = (1.0 - exp(-(tmpvar_116.z)));
    };
    L_115.z = tmpvar_119;
    vec4 tmpvar_120;
    tmpvar_120.w = 1.0;
    tmpvar_120.xyz = ((L_115 * _global_alpha) * tmpvar_114);
    tmpvar_1 = tmpvar_120;
  };
  gl_FragData[0] = tmpvar_1;
}


#endif
"
}
SubProgram "d3d9 " {
// Stats: 20 math, 1 branches
Bind "vertex" Vertex
Matrix 0 [glstate_matrix_modelview0]
Matrix 4 [glstate_matrix_mvp]
Vector 8 [_ProjectionParams]
Vector 9 [_ScreenParams]
Vector 10 [_MainTex_TexelSize]
"vs_3_0
dcl_position o0
dcl_texcoord0 o1
dcl_texcoord1 o2
dcl_texcoord2 o3
def c11, 0.50000000, 0.00000000, 1.00000000, 0
dcl_position0 v0
dp4 r1.z, v0, c7
dp4 r0.x, v0, c4
rcp r0.z, r1.z
mov r0.w, r1.z
dp4 r0.y, v0, c5
mul r2.xyz, r0.xyww, c11.x
mov r1.w, c11.y
mov r1.x, r2
mul r1.y, r2, c8.x
mad r1.xy, r2.z, c9.zwzw, r1
mul r2.zw, r1.xyxy, r0.z
mov r2.xy, r2.zwzw
dp4 r0.z, v0, c6
if_lt c10.y, r1.w
add r2.y, -r2, c11.z
endif
mov o0, r0
dp4 r0.x, v0, c2
mov o1.xyw, r1.xyzz
mov o2.xy, r2
mov o3.xy, r2.zwzw
mov o1.z, -r0.x
"
}
SubProgram "d3d11 " {
// Stats: 15 math
Bind "vertex" Vertex
ConstBuffer "$Globals" 384
Vector 288 [_MainTex_TexelSize]
ConstBuffer "UnityPerCamera" 128
Vector 80 [_ProjectionParams]
ConstBuffer "UnityPerDraw" 336
Matrix 0 [glstate_matrix_mvp]
Matrix 64 [glstate_matrix_modelview0]
BindCB  "$Globals" 0
BindCB  "UnityPerCamera" 1
BindCB  "UnityPerDraw" 2
"vs_4_0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"
}
SubProgram "gles " {
"!!GLES


#ifdef VERTEX

attribute vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
varying highp vec4 xlv_TEXCOORD0;
varying highp vec2 xlv_TEXCOORD1;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

#extension GL_EXT_shader_texture_lod : enable
uniform sampler2D _Inscatter;
uniform highp float M_PI;
uniform highp float HR;
uniform highp vec3 betaR;
uniform highp float HM;
uniform highp vec3 betaMEx;
uniform highp float mieG;
uniform highp float Rg;
uniform highp float Rt;
uniform highp float RES_R;
uniform highp float RES_MU;
uniform highp float RES_MU_S;
uniform highp float RES_NU;
uniform highp vec3 SUN_DIR;
uniform highp float SUN_INTENSITY;
uniform highp mat4 _ViewProjInv;
uniform highp float _experimentalAtmoScale;
uniform highp float _global_alpha;
uniform highp float _Exposure;
uniform highp float _global_depth;
uniform highp vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform sampler2D _godrayDepthTexture;
uniform highp float _openglThreshold;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp float godrayDepth_2;
  bool infinite_3;
  highp float depth_4;
  lowp float tmpvar_5;
  tmpvar_5 = texture2D (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_4 = tmpvar_5;
  infinite_3 = (depth_4 == 1.0);
  highp vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_6.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_6.z = depth_4;
  highp vec4 tmpvar_7;
  tmpvar_7 = (_ViewProjInv * tmpvar_6);
  highp float tmpvar_8;
  tmpvar_8 = (1.0 - abs(dot (normalize(((_camPos.yzx * SUN_DIR.zxy) - (_camPos.zxy * SUN_DIR.yzx))), normalize(((tmpvar_7 / tmpvar_7.w).xyz - _camPos)))));
  lowp float tmpvar_9;
  tmpvar_9 = texture2D (_godrayDepthTexture, xlv_TEXCOORD2).x;
  godrayDepth_2 = tmpvar_9;
  if ((((godrayDepth_2 > 0.0) && (godrayDepth_2 < depth_4)) && (depth_4 < 1.0))) {
    depth_4 = mix (depth_4, godrayDepth_2, tmpvar_8);
  };
  highp vec4 tmpvar_10;
  tmpvar_10.w = 1.0;
  tmpvar_10.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_10.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_10.z = depth_4;
  highp vec4 tmpvar_11;
  tmpvar_11 = (_ViewProjInv * tmpvar_10);
  highp vec3 tmpvar_12;
  tmpvar_12 = (tmpvar_11 / tmpvar_11.w).xyz;
  highp float tmpvar_13;
  highp vec3 tmpvar_14;
  tmpvar_14 = (tmpvar_12 - _camPos);
  highp float tmpvar_15;
  tmpvar_15 = dot (tmpvar_14, tmpvar_14);
  highp float tmpvar_16;
  tmpvar_16 = (2.0 * dot (tmpvar_14, _camPos));
  highp float tmpvar_17;
  tmpvar_17 = ((tmpvar_16 * tmpvar_16) - ((4.0 * tmpvar_15) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_17 < 0.0)) {
    tmpvar_13 = -1.0;
  } else {
    tmpvar_13 = ((-(tmpvar_16) - sqrt(tmpvar_17)) / (2.0 * tmpvar_15));
  };
  bool tmpvar_18;
  tmpvar_18 = (tmpvar_13 > 0.0);
  if ((!(tmpvar_18) && infinite_3)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    highp vec3 tmpvar_19;
    tmpvar_19 = (_camPos + (tmpvar_13 * (tmpvar_12 - _camPos)));
    highp vec3 arg0_20;
    arg0_20 = (tmpvar_19 - _camPos);
    highp vec3 arg0_21;
    arg0_21 = (tmpvar_12 - _camPos);
    bool tmpvar_22;
    tmpvar_22 = (sqrt(dot (arg0_20, arg0_20)) < sqrt(dot (arg0_21, arg0_21)));
    highp vec3 tmpvar_23;
    if ((tmpvar_18 && tmpvar_22)) {
      tmpvar_23 = tmpvar_19;
    } else {
      tmpvar_23 = tmpvar_12;
    };
    highp float tmpvar_24;
    tmpvar_24 = sqrt(dot (tmpvar_23, tmpvar_23));
    highp vec3 tmpvar_25;
    if ((tmpvar_24 < (Rg + _openglThreshold))) {
      tmpvar_25 = ((Rg + _openglThreshold) * normalize(tmpvar_23));
    } else {
      tmpvar_25 = tmpvar_23;
    };
    highp vec3 tmpvar_26;
    highp vec3 camera_27;
    camera_27 = _camPos;
    highp vec3 _point_28;
    _point_28 = tmpvar_25;
    highp vec3 extinction_29;
    highp vec4 inScatter0_30;
    highp float muS1_31;
    highp float mu1_32;
    highp vec4 inScatter_33;
    highp float mu_34;
    highp float rMu_35;
    highp float r_36;
    highp float d_37;
    extinction_29 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_38;
    tmpvar_38 = (tmpvar_25 - _camPos);
    highp float tmpvar_39;
    tmpvar_39 = sqrt(dot (tmpvar_38, tmpvar_38));
    d_37 = tmpvar_39;
    highp float tmpvar_40;
    tmpvar_40 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    highp vec3 tmpvar_41;
    tmpvar_41 = normalize((tmpvar_38 / tmpvar_39));
    highp float tmpvar_42;
    tmpvar_42 = sqrt(dot (_camPos, _camPos));
    r_36 = tmpvar_42;
    if ((tmpvar_42 < (0.9 * Rg))) {
      camera_27.y = (_camPos.y + Rg);
      _point_28.y = (tmpvar_25.y + Rg);
      r_36 = sqrt(dot (camera_27, camera_27));
    };
    highp float tmpvar_43;
    tmpvar_43 = dot (camera_27, tmpvar_41);
    rMu_35 = tmpvar_43;
    mu_34 = (tmpvar_43 / r_36);
    highp vec3 tmpvar_44;
    tmpvar_44 = (_point_28 - (tmpvar_41 * clamp (1.0, 0.0, tmpvar_39)));
    _point_28 = tmpvar_44;
    highp float f_45;
    f_45 = (((tmpvar_43 * tmpvar_43) - (r_36 * r_36)) + (tmpvar_40 * tmpvar_40));
    highp float tmpvar_46;
    if ((f_45 >= 0.0)) {
      tmpvar_46 = sqrt(f_45);
    } else {
      tmpvar_46 = 1e+30;
    };
    highp float tmpvar_47;
    tmpvar_47 = max ((-(tmpvar_43) - tmpvar_46), 0.0);
    if (((tmpvar_47 > 0.0) && (tmpvar_47 < tmpvar_39))) {
      camera_27 = (camera_27 + (tmpvar_47 * tmpvar_41));
      highp float tmpvar_48;
      tmpvar_48 = (tmpvar_43 + tmpvar_47);
      rMu_35 = tmpvar_48;
      mu_34 = (tmpvar_48 / tmpvar_40);
      r_36 = tmpvar_40;
      d_37 = (tmpvar_39 - tmpvar_47);
    };
    highp float tmpvar_49;
    tmpvar_49 = dot (tmpvar_41, SUN_DIR);
    highp float tmpvar_50;
    tmpvar_50 = (dot (camera_27, SUN_DIR) / r_36);
    if ((r_36 < (Rg + 1600.0))) {
      highp float tmpvar_51;
      tmpvar_51 = ((Rg + 1600.0) / r_36);
      r_36 = (r_36 * tmpvar_51);
      rMu_35 = (rMu_35 * tmpvar_51);
      _point_28 = (tmpvar_44 * tmpvar_51);
    };
    highp float tmpvar_52;
    tmpvar_52 = sqrt(dot (_point_28, _point_28));
    mu1_32 = (dot (_point_28, tmpvar_41) / tmpvar_52);
    muS1_31 = (dot (_point_28, SUN_DIR) / tmpvar_52);
    highp float tmpvar_53;
    highp vec2 tmpvar_54;
    tmpvar_54.x = mu_34;
    tmpvar_54.y = (mu_34 + (d_37 / r_36));
    highp vec2 tmpvar_55;
    tmpvar_55 = (sqrt(((0.5 / HR) * r_36)) * tmpvar_54);
    highp vec2 tmpvar_56;
    tmpvar_56 = sign(tmpvar_55);
    highp vec2 tmpvar_57;
    tmpvar_57 = (tmpvar_55 * tmpvar_55);
    highp float tmpvar_58;
    if ((tmpvar_56.y > tmpvar_56.x)) {
      tmpvar_58 = exp(tmpvar_57.x);
    } else {
      tmpvar_58 = 0.0;
    };
    highp vec2 tmpvar_59;
    tmpvar_59.x = 1.0;
    tmpvar_59.y = exp(((-(d_37) / HR) * ((d_37 / (2.0 * r_36)) + mu_34)));
    tmpvar_53 = ((sqrt(((6.2831 * HR) * r_36)) * exp(((Rg - r_36) / HR))) * (tmpvar_58 + dot (((tmpvar_56 / ((2.3193 * abs(tmpvar_55)) + sqrt(((1.52 * tmpvar_57) + 4.0)))) * tmpvar_59), vec2(1.0, -1.0))));
    highp vec2 tmpvar_60;
    tmpvar_60.x = mu_34;
    tmpvar_60.y = (mu_34 + (d_37 / r_36));
    highp vec2 tmpvar_61;
    tmpvar_61 = (sqrt(((0.5 / HM) * r_36)) * tmpvar_60);
    highp vec2 tmpvar_62;
    tmpvar_62 = sign(tmpvar_61);
    highp vec2 tmpvar_63;
    tmpvar_63 = (tmpvar_61 * tmpvar_61);
    highp float tmpvar_64;
    if ((tmpvar_62.y > tmpvar_62.x)) {
      tmpvar_64 = exp(tmpvar_63.x);
    } else {
      tmpvar_64 = 0.0;
    };
    highp vec2 tmpvar_65;
    tmpvar_65.x = 1.0;
    tmpvar_65.y = exp(((-(d_37) / HM) * ((d_37 / (2.0 * r_36)) + mu_34)));
    extinction_29 = min (exp(((-(betaR) * tmpvar_53) - (betaMEx * ((sqrt(((6.2831 * HM) * r_36)) * exp(((Rg - r_36) / HM))) * (tmpvar_64 + dot (((tmpvar_62 / ((2.3193 * abs(tmpvar_61)) + sqrt(((1.52 * tmpvar_63) + 4.0)))) * tmpvar_65), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    highp float uMu_66;
    highp float uR_67;
    highp float tmpvar_68;
    tmpvar_68 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    highp float tmpvar_69;
    tmpvar_69 = sqrt(((r_36 * r_36) - (Rg * Rg)));
    highp float tmpvar_70;
    tmpvar_70 = (r_36 * mu_34);
    highp float tmpvar_71;
    tmpvar_71 = (((tmpvar_70 * tmpvar_70) - (r_36 * r_36)) + (Rg * Rg));
    highp vec4 tmpvar_72;
    if (((tmpvar_70 < 0.0) && (tmpvar_71 > 0.0))) {
      highp vec4 tmpvar_73;
      tmpvar_73.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_73.w = (0.5 - (0.5 / RES_MU));
      tmpvar_72 = tmpvar_73;
    } else {
      highp vec4 tmpvar_74;
      tmpvar_74.x = -1.0;
      tmpvar_74.y = (tmpvar_68 * tmpvar_68);
      tmpvar_74.z = tmpvar_68;
      tmpvar_74.w = (0.5 + (0.5 / RES_MU));
      tmpvar_72 = tmpvar_74;
    };
    uR_67 = ((0.5 / RES_R) + ((tmpvar_69 / tmpvar_68) * (1.0 - (1.0/(RES_R)))));
    uMu_66 = (tmpvar_72.w + ((((tmpvar_70 * tmpvar_72.x) + sqrt((tmpvar_71 + tmpvar_72.y))) / (tmpvar_69 + tmpvar_72.z)) * (0.5 - (1.0/(RES_MU)))));
    highp float y_over_x_75;
    y_over_x_75 = (max (tmpvar_50, -0.1975) * 5.34962);
    highp float x_76;
    x_76 = (y_over_x_75 * inversesqrt(((y_over_x_75 * y_over_x_75) + 1.0)));
    highp float tmpvar_77;
    tmpvar_77 = ((0.5 / RES_MU_S) + (((((sign(x_76) * (1.5708 - (sqrt((1.0 - abs(x_76))) * (1.5708 + (abs(x_76) * (-0.214602 + (abs(x_76) * (0.0865667 + (abs(x_76) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    highp float tmpvar_78;
    tmpvar_78 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    highp float tmpvar_79;
    tmpvar_79 = floor(tmpvar_78);
    highp float tmpvar_80;
    tmpvar_80 = (tmpvar_78 - tmpvar_79);
    highp float tmpvar_81;
    tmpvar_81 = (floor(((uR_67 * RES_R) - 1.0)) / RES_R);
    highp float tmpvar_82;
    tmpvar_82 = (floor((uR_67 * RES_R)) / RES_R);
    highp float tmpvar_83;
    tmpvar_83 = fract((uR_67 * RES_R));
    highp vec4 tmpvar_84;
    tmpvar_84.zw = vec2(0.0, 0.0);
    tmpvar_84.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_84.y = ((uMu_66 / RES_R) + tmpvar_81);
    lowp vec4 tmpvar_85;
    tmpvar_85 = texture2DLodEXT (_Inscatter, tmpvar_84.xy, 0.0);
    highp vec4 tmpvar_86;
    tmpvar_86.zw = vec2(0.0, 0.0);
    tmpvar_86.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_86.y = ((uMu_66 / RES_R) + tmpvar_81);
    lowp vec4 tmpvar_87;
    tmpvar_87 = texture2DLodEXT (_Inscatter, tmpvar_86.xy, 0.0);
    highp vec4 tmpvar_88;
    tmpvar_88.zw = vec2(0.0, 0.0);
    tmpvar_88.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_88.y = ((uMu_66 / RES_R) + tmpvar_82);
    lowp vec4 tmpvar_89;
    tmpvar_89 = texture2DLodEXT (_Inscatter, tmpvar_88.xy, 0.0);
    highp vec4 tmpvar_90;
    tmpvar_90.zw = vec2(0.0, 0.0);
    tmpvar_90.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_90.y = ((uMu_66 / RES_R) + tmpvar_82);
    lowp vec4 tmpvar_91;
    tmpvar_91 = texture2DLodEXT (_Inscatter, tmpvar_90.xy, 0.0);
    inScatter0_30 = ((((tmpvar_85 * (1.0 - tmpvar_80)) + (tmpvar_87 * tmpvar_80)) * (1.0 - tmpvar_83)) + (((tmpvar_89 * (1.0 - tmpvar_80)) + (tmpvar_91 * tmpvar_80)) * tmpvar_83));
    highp float uMu_92;
    highp float uR_93;
    highp float tmpvar_94;
    tmpvar_94 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    highp float tmpvar_95;
    tmpvar_95 = sqrt(((tmpvar_52 * tmpvar_52) - (Rg * Rg)));
    highp float tmpvar_96;
    tmpvar_96 = (tmpvar_52 * mu1_32);
    highp float tmpvar_97;
    tmpvar_97 = (((tmpvar_96 * tmpvar_96) - (tmpvar_52 * tmpvar_52)) + (Rg * Rg));
    highp vec4 tmpvar_98;
    if (((tmpvar_96 < 0.0) && (tmpvar_97 > 0.0))) {
      highp vec4 tmpvar_99;
      tmpvar_99.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_99.w = (0.5 - (0.5 / RES_MU));
      tmpvar_98 = tmpvar_99;
    } else {
      highp vec4 tmpvar_100;
      tmpvar_100.x = -1.0;
      tmpvar_100.y = (tmpvar_94 * tmpvar_94);
      tmpvar_100.z = tmpvar_94;
      tmpvar_100.w = (0.5 + (0.5 / RES_MU));
      tmpvar_98 = tmpvar_100;
    };
    uR_93 = ((0.5 / RES_R) + ((tmpvar_95 / tmpvar_94) * (1.0 - (1.0/(RES_R)))));
    uMu_92 = (tmpvar_98.w + ((((tmpvar_96 * tmpvar_98.x) + sqrt((tmpvar_97 + tmpvar_98.y))) / (tmpvar_95 + tmpvar_98.z)) * (0.5 - (1.0/(RES_MU)))));
    highp float y_over_x_101;
    y_over_x_101 = (max (muS1_31, -0.1975) * 5.34962);
    highp float x_102;
    x_102 = (y_over_x_101 * inversesqrt(((y_over_x_101 * y_over_x_101) + 1.0)));
    highp float tmpvar_103;
    tmpvar_103 = ((0.5 / RES_MU_S) + (((((sign(x_102) * (1.5708 - (sqrt((1.0 - abs(x_102))) * (1.5708 + (abs(x_102) * (-0.214602 + (abs(x_102) * (0.0865667 + (abs(x_102) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    highp float tmpvar_104;
    tmpvar_104 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    highp float tmpvar_105;
    tmpvar_105 = floor(tmpvar_104);
    highp float tmpvar_106;
    tmpvar_106 = (tmpvar_104 - tmpvar_105);
    highp float tmpvar_107;
    tmpvar_107 = (floor(((uR_93 * RES_R) - 1.0)) / RES_R);
    highp float tmpvar_108;
    tmpvar_108 = (floor((uR_93 * RES_R)) / RES_R);
    highp float tmpvar_109;
    tmpvar_109 = fract((uR_93 * RES_R));
    highp vec4 tmpvar_110;
    tmpvar_110.zw = vec2(0.0, 0.0);
    tmpvar_110.x = ((tmpvar_105 + tmpvar_103) / RES_NU);
    tmpvar_110.y = ((uMu_92 / RES_R) + tmpvar_107);
    lowp vec4 tmpvar_111;
    tmpvar_111 = texture2DLodEXT (_Inscatter, tmpvar_110.xy, 0.0);
    highp vec4 tmpvar_112;
    tmpvar_112.zw = vec2(0.0, 0.0);
    tmpvar_112.x = (((tmpvar_105 + tmpvar_103) + 1.0) / RES_NU);
    tmpvar_112.y = ((uMu_92 / RES_R) + tmpvar_107);
    lowp vec4 tmpvar_113;
    tmpvar_113 = texture2DLodEXT (_Inscatter, tmpvar_112.xy, 0.0);
    highp vec4 tmpvar_114;
    tmpvar_114.zw = vec2(0.0, 0.0);
    tmpvar_114.x = ((tmpvar_105 + tmpvar_103) / RES_NU);
    tmpvar_114.y = ((uMu_92 / RES_R) + tmpvar_108);
    lowp vec4 tmpvar_115;
    tmpvar_115 = texture2DLodEXT (_Inscatter, tmpvar_114.xy, 0.0);
    highp vec4 tmpvar_116;
    tmpvar_116.zw = vec2(0.0, 0.0);
    tmpvar_116.x = (((tmpvar_105 + tmpvar_103) + 1.0) / RES_NU);
    tmpvar_116.y = ((uMu_92 / RES_R) + tmpvar_108);
    lowp vec4 tmpvar_117;
    tmpvar_117 = texture2DLodEXT (_Inscatter, tmpvar_116.xy, 0.0);
    highp vec4 tmpvar_118;
    tmpvar_118 = max ((inScatter0_30 - (((((tmpvar_111 * (1.0 - tmpvar_106)) + (tmpvar_113 * tmpvar_106)) * (1.0 - tmpvar_109)) + (((tmpvar_115 * (1.0 - tmpvar_106)) + (tmpvar_117 * tmpvar_106)) * tmpvar_109)) * extinction_29.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
    inScatter_33.xyz = tmpvar_118.xyz;
    highp float t_119;
    t_119 = max (min ((tmpvar_50 / 0.02), 1.0), 0.0);
    inScatter_33.w = (tmpvar_118.w * (t_119 * (t_119 * (3.0 - (2.0 * t_119)))));
    tmpvar_26 = (((tmpvar_118.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_49 * tmpvar_49)))) + ((((tmpvar_118.xyz * inScatter_33.w) / max (tmpvar_118.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_49)), -1.5)) * (1.0 + (tmpvar_49 * tmpvar_49))) / (2.0 + (mieG * mieG))))) * SUN_INTENSITY);
    highp float tmpvar_120;
    highp vec3 arg0_121;
    arg0_121 = (tmpvar_25 - _camPos);
    tmpvar_120 = sqrt(dot (arg0_121, arg0_121));
    highp float tmpvar_122;
    if ((tmpvar_120 <= _global_depth)) {
      tmpvar_122 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_120) / _global_depth))));
    } else {
      tmpvar_122 = 1.0;
    };
    highp vec3 L_123;
    highp vec3 tmpvar_124;
    tmpvar_124 = (tmpvar_26 * _Exposure);
    L_123 = tmpvar_124;
    highp float tmpvar_125;
    if ((tmpvar_124.x < 1.413)) {
      tmpvar_125 = pow ((tmpvar_124.x * 0.38317), 0.454545);
    } else {
      tmpvar_125 = (1.0 - exp(-(tmpvar_124.x)));
    };
    L_123.x = tmpvar_125;
    highp float tmpvar_126;
    if ((tmpvar_124.y < 1.413)) {
      tmpvar_126 = pow ((tmpvar_124.y * 0.38317), 0.454545);
    } else {
      tmpvar_126 = (1.0 - exp(-(tmpvar_124.y)));
    };
    L_123.y = tmpvar_126;
    highp float tmpvar_127;
    if ((tmpvar_124.z < 1.413)) {
      tmpvar_127 = pow ((tmpvar_124.z * 0.38317), 0.454545);
    } else {
      tmpvar_127 = (1.0 - exp(-(tmpvar_124.z)));
    };
    L_123.z = tmpvar_127;
    highp vec4 tmpvar_128;
    tmpvar_128.w = 1.0;
    tmpvar_128.xyz = ((L_123 * _global_alpha) * tmpvar_122);
    tmpvar_1 = tmpvar_128;
  };
  gl_FragData[0] = tmpvar_1;
}



#endif"
}
SubProgram "glesdesktop " {
"!!GLES


#ifdef VERTEX

attribute vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
varying highp vec4 xlv_TEXCOORD0;
varying highp vec2 xlv_TEXCOORD1;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

#extension GL_EXT_shader_texture_lod : enable
uniform sampler2D _Inscatter;
uniform highp float M_PI;
uniform highp float HR;
uniform highp vec3 betaR;
uniform highp float HM;
uniform highp vec3 betaMEx;
uniform highp float mieG;
uniform highp float Rg;
uniform highp float Rt;
uniform highp float RES_R;
uniform highp float RES_MU;
uniform highp float RES_MU_S;
uniform highp float RES_NU;
uniform highp vec3 SUN_DIR;
uniform highp float SUN_INTENSITY;
uniform highp mat4 _ViewProjInv;
uniform highp float _experimentalAtmoScale;
uniform highp float _global_alpha;
uniform highp float _Exposure;
uniform highp float _global_depth;
uniform highp vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform sampler2D _godrayDepthTexture;
uniform highp float _openglThreshold;
varying highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp float godrayDepth_2;
  bool infinite_3;
  highp float depth_4;
  lowp float tmpvar_5;
  tmpvar_5 = texture2D (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_4 = tmpvar_5;
  infinite_3 = (depth_4 == 1.0);
  highp vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_6.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_6.z = depth_4;
  highp vec4 tmpvar_7;
  tmpvar_7 = (_ViewProjInv * tmpvar_6);
  highp float tmpvar_8;
  tmpvar_8 = (1.0 - abs(dot (normalize(((_camPos.yzx * SUN_DIR.zxy) - (_camPos.zxy * SUN_DIR.yzx))), normalize(((tmpvar_7 / tmpvar_7.w).xyz - _camPos)))));
  lowp float tmpvar_9;
  tmpvar_9 = texture2D (_godrayDepthTexture, xlv_TEXCOORD2).x;
  godrayDepth_2 = tmpvar_9;
  if ((((godrayDepth_2 > 0.0) && (godrayDepth_2 < depth_4)) && (depth_4 < 1.0))) {
    depth_4 = mix (depth_4, godrayDepth_2, tmpvar_8);
  };
  highp vec4 tmpvar_10;
  tmpvar_10.w = 1.0;
  tmpvar_10.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_10.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_10.z = depth_4;
  highp vec4 tmpvar_11;
  tmpvar_11 = (_ViewProjInv * tmpvar_10);
  highp vec3 tmpvar_12;
  tmpvar_12 = (tmpvar_11 / tmpvar_11.w).xyz;
  highp float tmpvar_13;
  highp vec3 tmpvar_14;
  tmpvar_14 = (tmpvar_12 - _camPos);
  highp float tmpvar_15;
  tmpvar_15 = dot (tmpvar_14, tmpvar_14);
  highp float tmpvar_16;
  tmpvar_16 = (2.0 * dot (tmpvar_14, _camPos));
  highp float tmpvar_17;
  tmpvar_17 = ((tmpvar_16 * tmpvar_16) - ((4.0 * tmpvar_15) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_17 < 0.0)) {
    tmpvar_13 = -1.0;
  } else {
    tmpvar_13 = ((-(tmpvar_16) - sqrt(tmpvar_17)) / (2.0 * tmpvar_15));
  };
  bool tmpvar_18;
  tmpvar_18 = (tmpvar_13 > 0.0);
  if ((!(tmpvar_18) && infinite_3)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    highp vec3 tmpvar_19;
    tmpvar_19 = (_camPos + (tmpvar_13 * (tmpvar_12 - _camPos)));
    highp vec3 arg0_20;
    arg0_20 = (tmpvar_19 - _camPos);
    highp vec3 arg0_21;
    arg0_21 = (tmpvar_12 - _camPos);
    bool tmpvar_22;
    tmpvar_22 = (sqrt(dot (arg0_20, arg0_20)) < sqrt(dot (arg0_21, arg0_21)));
    highp vec3 tmpvar_23;
    if ((tmpvar_18 && tmpvar_22)) {
      tmpvar_23 = tmpvar_19;
    } else {
      tmpvar_23 = tmpvar_12;
    };
    highp float tmpvar_24;
    tmpvar_24 = sqrt(dot (tmpvar_23, tmpvar_23));
    highp vec3 tmpvar_25;
    if ((tmpvar_24 < (Rg + _openglThreshold))) {
      tmpvar_25 = ((Rg + _openglThreshold) * normalize(tmpvar_23));
    } else {
      tmpvar_25 = tmpvar_23;
    };
    highp vec3 tmpvar_26;
    highp vec3 camera_27;
    camera_27 = _camPos;
    highp vec3 _point_28;
    _point_28 = tmpvar_25;
    highp vec3 extinction_29;
    highp vec4 inScatter0_30;
    highp float muS1_31;
    highp float mu1_32;
    highp vec4 inScatter_33;
    highp float mu_34;
    highp float rMu_35;
    highp float r_36;
    highp float d_37;
    extinction_29 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_38;
    tmpvar_38 = (tmpvar_25 - _camPos);
    highp float tmpvar_39;
    tmpvar_39 = sqrt(dot (tmpvar_38, tmpvar_38));
    d_37 = tmpvar_39;
    highp float tmpvar_40;
    tmpvar_40 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    highp vec3 tmpvar_41;
    tmpvar_41 = normalize((tmpvar_38 / tmpvar_39));
    highp float tmpvar_42;
    tmpvar_42 = sqrt(dot (_camPos, _camPos));
    r_36 = tmpvar_42;
    if ((tmpvar_42 < (0.9 * Rg))) {
      camera_27.y = (_camPos.y + Rg);
      _point_28.y = (tmpvar_25.y + Rg);
      r_36 = sqrt(dot (camera_27, camera_27));
    };
    highp float tmpvar_43;
    tmpvar_43 = dot (camera_27, tmpvar_41);
    rMu_35 = tmpvar_43;
    mu_34 = (tmpvar_43 / r_36);
    highp vec3 tmpvar_44;
    tmpvar_44 = (_point_28 - (tmpvar_41 * clamp (1.0, 0.0, tmpvar_39)));
    _point_28 = tmpvar_44;
    highp float f_45;
    f_45 = (((tmpvar_43 * tmpvar_43) - (r_36 * r_36)) + (tmpvar_40 * tmpvar_40));
    highp float tmpvar_46;
    if ((f_45 >= 0.0)) {
      tmpvar_46 = sqrt(f_45);
    } else {
      tmpvar_46 = 1e+30;
    };
    highp float tmpvar_47;
    tmpvar_47 = max ((-(tmpvar_43) - tmpvar_46), 0.0);
    if (((tmpvar_47 > 0.0) && (tmpvar_47 < tmpvar_39))) {
      camera_27 = (camera_27 + (tmpvar_47 * tmpvar_41));
      highp float tmpvar_48;
      tmpvar_48 = (tmpvar_43 + tmpvar_47);
      rMu_35 = tmpvar_48;
      mu_34 = (tmpvar_48 / tmpvar_40);
      r_36 = tmpvar_40;
      d_37 = (tmpvar_39 - tmpvar_47);
    };
    highp float tmpvar_49;
    tmpvar_49 = dot (tmpvar_41, SUN_DIR);
    highp float tmpvar_50;
    tmpvar_50 = (dot (camera_27, SUN_DIR) / r_36);
    if ((r_36 < (Rg + 1600.0))) {
      highp float tmpvar_51;
      tmpvar_51 = ((Rg + 1600.0) / r_36);
      r_36 = (r_36 * tmpvar_51);
      rMu_35 = (rMu_35 * tmpvar_51);
      _point_28 = (tmpvar_44 * tmpvar_51);
    };
    highp float tmpvar_52;
    tmpvar_52 = sqrt(dot (_point_28, _point_28));
    mu1_32 = (dot (_point_28, tmpvar_41) / tmpvar_52);
    muS1_31 = (dot (_point_28, SUN_DIR) / tmpvar_52);
    highp float tmpvar_53;
    highp vec2 tmpvar_54;
    tmpvar_54.x = mu_34;
    tmpvar_54.y = (mu_34 + (d_37 / r_36));
    highp vec2 tmpvar_55;
    tmpvar_55 = (sqrt(((0.5 / HR) * r_36)) * tmpvar_54);
    highp vec2 tmpvar_56;
    tmpvar_56 = sign(tmpvar_55);
    highp vec2 tmpvar_57;
    tmpvar_57 = (tmpvar_55 * tmpvar_55);
    highp float tmpvar_58;
    if ((tmpvar_56.y > tmpvar_56.x)) {
      tmpvar_58 = exp(tmpvar_57.x);
    } else {
      tmpvar_58 = 0.0;
    };
    highp vec2 tmpvar_59;
    tmpvar_59.x = 1.0;
    tmpvar_59.y = exp(((-(d_37) / HR) * ((d_37 / (2.0 * r_36)) + mu_34)));
    tmpvar_53 = ((sqrt(((6.2831 * HR) * r_36)) * exp(((Rg - r_36) / HR))) * (tmpvar_58 + dot (((tmpvar_56 / ((2.3193 * abs(tmpvar_55)) + sqrt(((1.52 * tmpvar_57) + 4.0)))) * tmpvar_59), vec2(1.0, -1.0))));
    highp vec2 tmpvar_60;
    tmpvar_60.x = mu_34;
    tmpvar_60.y = (mu_34 + (d_37 / r_36));
    highp vec2 tmpvar_61;
    tmpvar_61 = (sqrt(((0.5 / HM) * r_36)) * tmpvar_60);
    highp vec2 tmpvar_62;
    tmpvar_62 = sign(tmpvar_61);
    highp vec2 tmpvar_63;
    tmpvar_63 = (tmpvar_61 * tmpvar_61);
    highp float tmpvar_64;
    if ((tmpvar_62.y > tmpvar_62.x)) {
      tmpvar_64 = exp(tmpvar_63.x);
    } else {
      tmpvar_64 = 0.0;
    };
    highp vec2 tmpvar_65;
    tmpvar_65.x = 1.0;
    tmpvar_65.y = exp(((-(d_37) / HM) * ((d_37 / (2.0 * r_36)) + mu_34)));
    extinction_29 = min (exp(((-(betaR) * tmpvar_53) - (betaMEx * ((sqrt(((6.2831 * HM) * r_36)) * exp(((Rg - r_36) / HM))) * (tmpvar_64 + dot (((tmpvar_62 / ((2.3193 * abs(tmpvar_61)) + sqrt(((1.52 * tmpvar_63) + 4.0)))) * tmpvar_65), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    highp float uMu_66;
    highp float uR_67;
    highp float tmpvar_68;
    tmpvar_68 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    highp float tmpvar_69;
    tmpvar_69 = sqrt(((r_36 * r_36) - (Rg * Rg)));
    highp float tmpvar_70;
    tmpvar_70 = (r_36 * mu_34);
    highp float tmpvar_71;
    tmpvar_71 = (((tmpvar_70 * tmpvar_70) - (r_36 * r_36)) + (Rg * Rg));
    highp vec4 tmpvar_72;
    if (((tmpvar_70 < 0.0) && (tmpvar_71 > 0.0))) {
      highp vec4 tmpvar_73;
      tmpvar_73.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_73.w = (0.5 - (0.5 / RES_MU));
      tmpvar_72 = tmpvar_73;
    } else {
      highp vec4 tmpvar_74;
      tmpvar_74.x = -1.0;
      tmpvar_74.y = (tmpvar_68 * tmpvar_68);
      tmpvar_74.z = tmpvar_68;
      tmpvar_74.w = (0.5 + (0.5 / RES_MU));
      tmpvar_72 = tmpvar_74;
    };
    uR_67 = ((0.5 / RES_R) + ((tmpvar_69 / tmpvar_68) * (1.0 - (1.0/(RES_R)))));
    uMu_66 = (tmpvar_72.w + ((((tmpvar_70 * tmpvar_72.x) + sqrt((tmpvar_71 + tmpvar_72.y))) / (tmpvar_69 + tmpvar_72.z)) * (0.5 - (1.0/(RES_MU)))));
    highp float y_over_x_75;
    y_over_x_75 = (max (tmpvar_50, -0.1975) * 5.34962);
    highp float x_76;
    x_76 = (y_over_x_75 * inversesqrt(((y_over_x_75 * y_over_x_75) + 1.0)));
    highp float tmpvar_77;
    tmpvar_77 = ((0.5 / RES_MU_S) + (((((sign(x_76) * (1.5708 - (sqrt((1.0 - abs(x_76))) * (1.5708 + (abs(x_76) * (-0.214602 + (abs(x_76) * (0.0865667 + (abs(x_76) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    highp float tmpvar_78;
    tmpvar_78 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    highp float tmpvar_79;
    tmpvar_79 = floor(tmpvar_78);
    highp float tmpvar_80;
    tmpvar_80 = (tmpvar_78 - tmpvar_79);
    highp float tmpvar_81;
    tmpvar_81 = (floor(((uR_67 * RES_R) - 1.0)) / RES_R);
    highp float tmpvar_82;
    tmpvar_82 = (floor((uR_67 * RES_R)) / RES_R);
    highp float tmpvar_83;
    tmpvar_83 = fract((uR_67 * RES_R));
    highp vec4 tmpvar_84;
    tmpvar_84.zw = vec2(0.0, 0.0);
    tmpvar_84.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_84.y = ((uMu_66 / RES_R) + tmpvar_81);
    lowp vec4 tmpvar_85;
    tmpvar_85 = texture2DLodEXT (_Inscatter, tmpvar_84.xy, 0.0);
    highp vec4 tmpvar_86;
    tmpvar_86.zw = vec2(0.0, 0.0);
    tmpvar_86.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_86.y = ((uMu_66 / RES_R) + tmpvar_81);
    lowp vec4 tmpvar_87;
    tmpvar_87 = texture2DLodEXT (_Inscatter, tmpvar_86.xy, 0.0);
    highp vec4 tmpvar_88;
    tmpvar_88.zw = vec2(0.0, 0.0);
    tmpvar_88.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_88.y = ((uMu_66 / RES_R) + tmpvar_82);
    lowp vec4 tmpvar_89;
    tmpvar_89 = texture2DLodEXT (_Inscatter, tmpvar_88.xy, 0.0);
    highp vec4 tmpvar_90;
    tmpvar_90.zw = vec2(0.0, 0.0);
    tmpvar_90.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_90.y = ((uMu_66 / RES_R) + tmpvar_82);
    lowp vec4 tmpvar_91;
    tmpvar_91 = texture2DLodEXT (_Inscatter, tmpvar_90.xy, 0.0);
    inScatter0_30 = ((((tmpvar_85 * (1.0 - tmpvar_80)) + (tmpvar_87 * tmpvar_80)) * (1.0 - tmpvar_83)) + (((tmpvar_89 * (1.0 - tmpvar_80)) + (tmpvar_91 * tmpvar_80)) * tmpvar_83));
    highp float uMu_92;
    highp float uR_93;
    highp float tmpvar_94;
    tmpvar_94 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    highp float tmpvar_95;
    tmpvar_95 = sqrt(((tmpvar_52 * tmpvar_52) - (Rg * Rg)));
    highp float tmpvar_96;
    tmpvar_96 = (tmpvar_52 * mu1_32);
    highp float tmpvar_97;
    tmpvar_97 = (((tmpvar_96 * tmpvar_96) - (tmpvar_52 * tmpvar_52)) + (Rg * Rg));
    highp vec4 tmpvar_98;
    if (((tmpvar_96 < 0.0) && (tmpvar_97 > 0.0))) {
      highp vec4 tmpvar_99;
      tmpvar_99.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_99.w = (0.5 - (0.5 / RES_MU));
      tmpvar_98 = tmpvar_99;
    } else {
      highp vec4 tmpvar_100;
      tmpvar_100.x = -1.0;
      tmpvar_100.y = (tmpvar_94 * tmpvar_94);
      tmpvar_100.z = tmpvar_94;
      tmpvar_100.w = (0.5 + (0.5 / RES_MU));
      tmpvar_98 = tmpvar_100;
    };
    uR_93 = ((0.5 / RES_R) + ((tmpvar_95 / tmpvar_94) * (1.0 - (1.0/(RES_R)))));
    uMu_92 = (tmpvar_98.w + ((((tmpvar_96 * tmpvar_98.x) + sqrt((tmpvar_97 + tmpvar_98.y))) / (tmpvar_95 + tmpvar_98.z)) * (0.5 - (1.0/(RES_MU)))));
    highp float y_over_x_101;
    y_over_x_101 = (max (muS1_31, -0.1975) * 5.34962);
    highp float x_102;
    x_102 = (y_over_x_101 * inversesqrt(((y_over_x_101 * y_over_x_101) + 1.0)));
    highp float tmpvar_103;
    tmpvar_103 = ((0.5 / RES_MU_S) + (((((sign(x_102) * (1.5708 - (sqrt((1.0 - abs(x_102))) * (1.5708 + (abs(x_102) * (-0.214602 + (abs(x_102) * (0.0865667 + (abs(x_102) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    highp float tmpvar_104;
    tmpvar_104 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    highp float tmpvar_105;
    tmpvar_105 = floor(tmpvar_104);
    highp float tmpvar_106;
    tmpvar_106 = (tmpvar_104 - tmpvar_105);
    highp float tmpvar_107;
    tmpvar_107 = (floor(((uR_93 * RES_R) - 1.0)) / RES_R);
    highp float tmpvar_108;
    tmpvar_108 = (floor((uR_93 * RES_R)) / RES_R);
    highp float tmpvar_109;
    tmpvar_109 = fract((uR_93 * RES_R));
    highp vec4 tmpvar_110;
    tmpvar_110.zw = vec2(0.0, 0.0);
    tmpvar_110.x = ((tmpvar_105 + tmpvar_103) / RES_NU);
    tmpvar_110.y = ((uMu_92 / RES_R) + tmpvar_107);
    lowp vec4 tmpvar_111;
    tmpvar_111 = texture2DLodEXT (_Inscatter, tmpvar_110.xy, 0.0);
    highp vec4 tmpvar_112;
    tmpvar_112.zw = vec2(0.0, 0.0);
    tmpvar_112.x = (((tmpvar_105 + tmpvar_103) + 1.0) / RES_NU);
    tmpvar_112.y = ((uMu_92 / RES_R) + tmpvar_107);
    lowp vec4 tmpvar_113;
    tmpvar_113 = texture2DLodEXT (_Inscatter, tmpvar_112.xy, 0.0);
    highp vec4 tmpvar_114;
    tmpvar_114.zw = vec2(0.0, 0.0);
    tmpvar_114.x = ((tmpvar_105 + tmpvar_103) / RES_NU);
    tmpvar_114.y = ((uMu_92 / RES_R) + tmpvar_108);
    lowp vec4 tmpvar_115;
    tmpvar_115 = texture2DLodEXT (_Inscatter, tmpvar_114.xy, 0.0);
    highp vec4 tmpvar_116;
    tmpvar_116.zw = vec2(0.0, 0.0);
    tmpvar_116.x = (((tmpvar_105 + tmpvar_103) + 1.0) / RES_NU);
    tmpvar_116.y = ((uMu_92 / RES_R) + tmpvar_108);
    lowp vec4 tmpvar_117;
    tmpvar_117 = texture2DLodEXT (_Inscatter, tmpvar_116.xy, 0.0);
    highp vec4 tmpvar_118;
    tmpvar_118 = max ((inScatter0_30 - (((((tmpvar_111 * (1.0 - tmpvar_106)) + (tmpvar_113 * tmpvar_106)) * (1.0 - tmpvar_109)) + (((tmpvar_115 * (1.0 - tmpvar_106)) + (tmpvar_117 * tmpvar_106)) * tmpvar_109)) * extinction_29.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
    inScatter_33.xyz = tmpvar_118.xyz;
    highp float t_119;
    t_119 = max (min ((tmpvar_50 / 0.02), 1.0), 0.0);
    inScatter_33.w = (tmpvar_118.w * (t_119 * (t_119 * (3.0 - (2.0 * t_119)))));
    tmpvar_26 = (((tmpvar_118.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_49 * tmpvar_49)))) + ((((tmpvar_118.xyz * inScatter_33.w) / max (tmpvar_118.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_49)), -1.5)) * (1.0 + (tmpvar_49 * tmpvar_49))) / (2.0 + (mieG * mieG))))) * SUN_INTENSITY);
    highp float tmpvar_120;
    highp vec3 arg0_121;
    arg0_121 = (tmpvar_25 - _camPos);
    tmpvar_120 = sqrt(dot (arg0_121, arg0_121));
    highp float tmpvar_122;
    if ((tmpvar_120 <= _global_depth)) {
      tmpvar_122 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_120) / _global_depth))));
    } else {
      tmpvar_122 = 1.0;
    };
    highp vec3 L_123;
    highp vec3 tmpvar_124;
    tmpvar_124 = (tmpvar_26 * _Exposure);
    L_123 = tmpvar_124;
    highp float tmpvar_125;
    if ((tmpvar_124.x < 1.413)) {
      tmpvar_125 = pow ((tmpvar_124.x * 0.38317), 0.454545);
    } else {
      tmpvar_125 = (1.0 - exp(-(tmpvar_124.x)));
    };
    L_123.x = tmpvar_125;
    highp float tmpvar_126;
    if ((tmpvar_124.y < 1.413)) {
      tmpvar_126 = pow ((tmpvar_124.y * 0.38317), 0.454545);
    } else {
      tmpvar_126 = (1.0 - exp(-(tmpvar_124.y)));
    };
    L_123.y = tmpvar_126;
    highp float tmpvar_127;
    if ((tmpvar_124.z < 1.413)) {
      tmpvar_127 = pow ((tmpvar_124.z * 0.38317), 0.454545);
    } else {
      tmpvar_127 = (1.0 - exp(-(tmpvar_124.z)));
    };
    L_123.z = tmpvar_127;
    highp vec4 tmpvar_128;
    tmpvar_128.w = 1.0;
    tmpvar_128.xyz = ((L_123 * _global_alpha) * tmpvar_122);
    tmpvar_1 = tmpvar_128;
  };
  gl_FragData[0] = tmpvar_1;
}



#endif"
}
SubProgram "gles3 " {
"!!GLES3#version 300 es


#ifdef VERTEX

in vec4 _glesVertex;
uniform highp vec4 _ProjectionParams;
uniform highp mat4 glstate_matrix_mvp;
uniform highp mat4 glstate_matrix_modelview0;
out highp vec4 xlv_TEXCOORD0;
out highp vec2 xlv_TEXCOORD1;
out highp vec2 xlv_TEXCOORD2;
void main ()
{
  highp vec4 tmpvar_1;
  highp vec4 tmpvar_2;
  tmpvar_2 = (glstate_matrix_mvp * _glesVertex);
  highp vec4 o_3;
  highp vec4 tmpvar_4;
  tmpvar_4 = (tmpvar_2 * 0.5);
  highp vec2 tmpvar_5;
  tmpvar_5.x = tmpvar_4.x;
  tmpvar_5.y = (tmpvar_4.y * _ProjectionParams.x);
  o_3.xy = (tmpvar_5 + tmpvar_4.w);
  o_3.zw = tmpvar_2.zw;
  tmpvar_1.xyw = o_3.xyw;
  highp vec2 tmpvar_6;
  tmpvar_6 = (o_3.xy / tmpvar_2.w);
  tmpvar_1.z = -((glstate_matrix_modelview0 * _glesVertex).z);
  gl_Position = tmpvar_2;
  xlv_TEXCOORD0 = tmpvar_1;
  xlv_TEXCOORD1 = tmpvar_6;
  xlv_TEXCOORD2 = tmpvar_6;
}



#endif
#ifdef FRAGMENT

out mediump vec4 _glesFragData[4];
uniform sampler2D _Inscatter;
uniform highp float M_PI;
uniform highp float HR;
uniform highp vec3 betaR;
uniform highp float HM;
uniform highp vec3 betaMEx;
uniform highp float mieG;
uniform highp float Rg;
uniform highp float Rt;
uniform highp float RES_R;
uniform highp float RES_MU;
uniform highp float RES_MU_S;
uniform highp float RES_NU;
uniform highp vec3 SUN_DIR;
uniform highp float SUN_INTENSITY;
uniform highp mat4 _ViewProjInv;
uniform highp float _experimentalAtmoScale;
uniform highp float _global_alpha;
uniform highp float _Exposure;
uniform highp float _global_depth;
uniform highp vec3 _camPos;
uniform sampler2D _customDepthTexture;
uniform sampler2D _godrayDepthTexture;
uniform highp float _openglThreshold;
in highp vec2 xlv_TEXCOORD2;
void main ()
{
  mediump vec4 tmpvar_1;
  highp float godrayDepth_2;
  bool infinite_3;
  highp float depth_4;
  lowp float tmpvar_5;
  tmpvar_5 = texture (_customDepthTexture, xlv_TEXCOORD2).x;
  depth_4 = tmpvar_5;
  infinite_3 = (depth_4 == 1.0);
  highp vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_6.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_6.z = depth_4;
  highp vec4 tmpvar_7;
  tmpvar_7 = (_ViewProjInv * tmpvar_6);
  highp float tmpvar_8;
  tmpvar_8 = (1.0 - abs(dot (normalize(((_camPos.yzx * SUN_DIR.zxy) - (_camPos.zxy * SUN_DIR.yzx))), normalize(((tmpvar_7 / tmpvar_7.w).xyz - _camPos)))));
  lowp float tmpvar_9;
  tmpvar_9 = texture (_godrayDepthTexture, xlv_TEXCOORD2).x;
  godrayDepth_2 = tmpvar_9;
  if ((((godrayDepth_2 > 0.0) && (godrayDepth_2 < depth_4)) && (depth_4 < 1.0))) {
    depth_4 = mix (depth_4, godrayDepth_2, tmpvar_8);
  };
  highp vec4 tmpvar_10;
  tmpvar_10.w = 1.0;
  tmpvar_10.x = ((xlv_TEXCOORD2.x * 2.0) - 1.0);
  tmpvar_10.y = ((xlv_TEXCOORD2.y * 2.0) - 1.0);
  tmpvar_10.z = depth_4;
  highp vec4 tmpvar_11;
  tmpvar_11 = (_ViewProjInv * tmpvar_10);
  highp vec3 tmpvar_12;
  tmpvar_12 = (tmpvar_11 / tmpvar_11.w).xyz;
  highp float tmpvar_13;
  highp vec3 tmpvar_14;
  tmpvar_14 = (tmpvar_12 - _camPos);
  highp float tmpvar_15;
  tmpvar_15 = dot (tmpvar_14, tmpvar_14);
  highp float tmpvar_16;
  tmpvar_16 = (2.0 * dot (tmpvar_14, _camPos));
  highp float tmpvar_17;
  tmpvar_17 = ((tmpvar_16 * tmpvar_16) - ((4.0 * tmpvar_15) * (dot (_camPos, _camPos) - (Rg * Rg))));
  if ((tmpvar_17 < 0.0)) {
    tmpvar_13 = -1.0;
  } else {
    tmpvar_13 = ((-(tmpvar_16) - sqrt(tmpvar_17)) / (2.0 * tmpvar_15));
  };
  bool tmpvar_18;
  tmpvar_18 = (tmpvar_13 > 0.0);
  if ((!(tmpvar_18) && infinite_3)) {
    tmpvar_1 = vec4(0.0, 0.0, 0.0, 0.0);
  } else {
    highp vec3 tmpvar_19;
    tmpvar_19 = (_camPos + (tmpvar_13 * (tmpvar_12 - _camPos)));
    highp vec3 arg0_20;
    arg0_20 = (tmpvar_19 - _camPos);
    highp vec3 arg0_21;
    arg0_21 = (tmpvar_12 - _camPos);
    bool tmpvar_22;
    tmpvar_22 = (sqrt(dot (arg0_20, arg0_20)) < sqrt(dot (arg0_21, arg0_21)));
    highp vec3 tmpvar_23;
    if ((tmpvar_18 && tmpvar_22)) {
      tmpvar_23 = tmpvar_19;
    } else {
      tmpvar_23 = tmpvar_12;
    };
    highp float tmpvar_24;
    tmpvar_24 = sqrt(dot (tmpvar_23, tmpvar_23));
    highp vec3 tmpvar_25;
    if ((tmpvar_24 < (Rg + _openglThreshold))) {
      tmpvar_25 = ((Rg + _openglThreshold) * normalize(tmpvar_23));
    } else {
      tmpvar_25 = tmpvar_23;
    };
    highp vec3 tmpvar_26;
    highp vec3 camera_27;
    camera_27 = _camPos;
    highp vec3 _point_28;
    _point_28 = tmpvar_25;
    highp vec3 extinction_29;
    highp vec4 inScatter0_30;
    highp float muS1_31;
    highp float mu1_32;
    highp vec4 inScatter_33;
    highp float mu_34;
    highp float rMu_35;
    highp float r_36;
    highp float d_37;
    extinction_29 = vec3(1.0, 1.0, 1.0);
    highp vec3 tmpvar_38;
    tmpvar_38 = (tmpvar_25 - _camPos);
    highp float tmpvar_39;
    tmpvar_39 = sqrt(dot (tmpvar_38, tmpvar_38));
    d_37 = tmpvar_39;
    highp float tmpvar_40;
    tmpvar_40 = (Rg + ((Rt - Rg) * _experimentalAtmoScale));
    highp vec3 tmpvar_41;
    tmpvar_41 = normalize((tmpvar_38 / tmpvar_39));
    highp float tmpvar_42;
    tmpvar_42 = sqrt(dot (_camPos, _camPos));
    r_36 = tmpvar_42;
    if ((tmpvar_42 < (0.9 * Rg))) {
      camera_27.y = (_camPos.y + Rg);
      _point_28.y = (tmpvar_25.y + Rg);
      r_36 = sqrt(dot (camera_27, camera_27));
    };
    highp float tmpvar_43;
    tmpvar_43 = dot (camera_27, tmpvar_41);
    rMu_35 = tmpvar_43;
    mu_34 = (tmpvar_43 / r_36);
    highp vec3 tmpvar_44;
    tmpvar_44 = (_point_28 - (tmpvar_41 * clamp (1.0, 0.0, tmpvar_39)));
    _point_28 = tmpvar_44;
    highp float f_45;
    f_45 = (((tmpvar_43 * tmpvar_43) - (r_36 * r_36)) + (tmpvar_40 * tmpvar_40));
    highp float tmpvar_46;
    if ((f_45 >= 0.0)) {
      tmpvar_46 = sqrt(f_45);
    } else {
      tmpvar_46 = 1e+30;
    };
    highp float tmpvar_47;
    tmpvar_47 = max ((-(tmpvar_43) - tmpvar_46), 0.0);
    if (((tmpvar_47 > 0.0) && (tmpvar_47 < tmpvar_39))) {
      camera_27 = (camera_27 + (tmpvar_47 * tmpvar_41));
      highp float tmpvar_48;
      tmpvar_48 = (tmpvar_43 + tmpvar_47);
      rMu_35 = tmpvar_48;
      mu_34 = (tmpvar_48 / tmpvar_40);
      r_36 = tmpvar_40;
      d_37 = (tmpvar_39 - tmpvar_47);
    };
    highp float tmpvar_49;
    tmpvar_49 = dot (tmpvar_41, SUN_DIR);
    highp float tmpvar_50;
    tmpvar_50 = (dot (camera_27, SUN_DIR) / r_36);
    if ((r_36 < (Rg + 1600.0))) {
      highp float tmpvar_51;
      tmpvar_51 = ((Rg + 1600.0) / r_36);
      r_36 = (r_36 * tmpvar_51);
      rMu_35 = (rMu_35 * tmpvar_51);
      _point_28 = (tmpvar_44 * tmpvar_51);
    };
    highp float tmpvar_52;
    tmpvar_52 = sqrt(dot (_point_28, _point_28));
    mu1_32 = (dot (_point_28, tmpvar_41) / tmpvar_52);
    muS1_31 = (dot (_point_28, SUN_DIR) / tmpvar_52);
    highp float tmpvar_53;
    highp vec2 tmpvar_54;
    tmpvar_54.x = mu_34;
    tmpvar_54.y = (mu_34 + (d_37 / r_36));
    highp vec2 tmpvar_55;
    tmpvar_55 = (sqrt(((0.5 / HR) * r_36)) * tmpvar_54);
    highp vec2 tmpvar_56;
    tmpvar_56 = sign(tmpvar_55);
    highp vec2 tmpvar_57;
    tmpvar_57 = (tmpvar_55 * tmpvar_55);
    highp float tmpvar_58;
    if ((tmpvar_56.y > tmpvar_56.x)) {
      tmpvar_58 = exp(tmpvar_57.x);
    } else {
      tmpvar_58 = 0.0;
    };
    highp vec2 tmpvar_59;
    tmpvar_59.x = 1.0;
    tmpvar_59.y = exp(((-(d_37) / HR) * ((d_37 / (2.0 * r_36)) + mu_34)));
    tmpvar_53 = ((sqrt(((6.2831 * HR) * r_36)) * exp(((Rg - r_36) / HR))) * (tmpvar_58 + dot (((tmpvar_56 / ((2.3193 * abs(tmpvar_55)) + sqrt(((1.52 * tmpvar_57) + 4.0)))) * tmpvar_59), vec2(1.0, -1.0))));
    highp vec2 tmpvar_60;
    tmpvar_60.x = mu_34;
    tmpvar_60.y = (mu_34 + (d_37 / r_36));
    highp vec2 tmpvar_61;
    tmpvar_61 = (sqrt(((0.5 / HM) * r_36)) * tmpvar_60);
    highp vec2 tmpvar_62;
    tmpvar_62 = sign(tmpvar_61);
    highp vec2 tmpvar_63;
    tmpvar_63 = (tmpvar_61 * tmpvar_61);
    highp float tmpvar_64;
    if ((tmpvar_62.y > tmpvar_62.x)) {
      tmpvar_64 = exp(tmpvar_63.x);
    } else {
      tmpvar_64 = 0.0;
    };
    highp vec2 tmpvar_65;
    tmpvar_65.x = 1.0;
    tmpvar_65.y = exp(((-(d_37) / HM) * ((d_37 / (2.0 * r_36)) + mu_34)));
    extinction_29 = min (exp(((-(betaR) * tmpvar_53) - (betaMEx * ((sqrt(((6.2831 * HM) * r_36)) * exp(((Rg - r_36) / HM))) * (tmpvar_64 + dot (((tmpvar_62 / ((2.3193 * abs(tmpvar_61)) + sqrt(((1.52 * tmpvar_63) + 4.0)))) * tmpvar_65), vec2(1.0, -1.0))))))), vec3(1.0, 1.0, 1.0));
    highp float uMu_66;
    highp float uR_67;
    highp float tmpvar_68;
    tmpvar_68 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    highp float tmpvar_69;
    tmpvar_69 = sqrt(((r_36 * r_36) - (Rg * Rg)));
    highp float tmpvar_70;
    tmpvar_70 = (r_36 * mu_34);
    highp float tmpvar_71;
    tmpvar_71 = (((tmpvar_70 * tmpvar_70) - (r_36 * r_36)) + (Rg * Rg));
    highp vec4 tmpvar_72;
    if (((tmpvar_70 < 0.0) && (tmpvar_71 > 0.0))) {
      highp vec4 tmpvar_73;
      tmpvar_73.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_73.w = (0.5 - (0.5 / RES_MU));
      tmpvar_72 = tmpvar_73;
    } else {
      highp vec4 tmpvar_74;
      tmpvar_74.x = -1.0;
      tmpvar_74.y = (tmpvar_68 * tmpvar_68);
      tmpvar_74.z = tmpvar_68;
      tmpvar_74.w = (0.5 + (0.5 / RES_MU));
      tmpvar_72 = tmpvar_74;
    };
    uR_67 = ((0.5 / RES_R) + ((tmpvar_69 / tmpvar_68) * (1.0 - (1.0/(RES_R)))));
    uMu_66 = (tmpvar_72.w + ((((tmpvar_70 * tmpvar_72.x) + sqrt((tmpvar_71 + tmpvar_72.y))) / (tmpvar_69 + tmpvar_72.z)) * (0.5 - (1.0/(RES_MU)))));
    highp float y_over_x_75;
    y_over_x_75 = (max (tmpvar_50, -0.1975) * 5.34962);
    highp float x_76;
    x_76 = (y_over_x_75 * inversesqrt(((y_over_x_75 * y_over_x_75) + 1.0)));
    highp float tmpvar_77;
    tmpvar_77 = ((0.5 / RES_MU_S) + (((((sign(x_76) * (1.5708 - (sqrt((1.0 - abs(x_76))) * (1.5708 + (abs(x_76) * (-0.214602 + (abs(x_76) * (0.0865667 + (abs(x_76) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    highp float tmpvar_78;
    tmpvar_78 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    highp float tmpvar_79;
    tmpvar_79 = floor(tmpvar_78);
    highp float tmpvar_80;
    tmpvar_80 = (tmpvar_78 - tmpvar_79);
    highp float tmpvar_81;
    tmpvar_81 = (floor(((uR_67 * RES_R) - 1.0)) / RES_R);
    highp float tmpvar_82;
    tmpvar_82 = (floor((uR_67 * RES_R)) / RES_R);
    highp float tmpvar_83;
    tmpvar_83 = fract((uR_67 * RES_R));
    highp vec4 tmpvar_84;
    tmpvar_84.zw = vec2(0.0, 0.0);
    tmpvar_84.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_84.y = ((uMu_66 / RES_R) + tmpvar_81);
    lowp vec4 tmpvar_85;
    tmpvar_85 = textureLod (_Inscatter, tmpvar_84.xy, 0.0);
    highp vec4 tmpvar_86;
    tmpvar_86.zw = vec2(0.0, 0.0);
    tmpvar_86.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_86.y = ((uMu_66 / RES_R) + tmpvar_81);
    lowp vec4 tmpvar_87;
    tmpvar_87 = textureLod (_Inscatter, tmpvar_86.xy, 0.0);
    highp vec4 tmpvar_88;
    tmpvar_88.zw = vec2(0.0, 0.0);
    tmpvar_88.x = ((tmpvar_79 + tmpvar_77) / RES_NU);
    tmpvar_88.y = ((uMu_66 / RES_R) + tmpvar_82);
    lowp vec4 tmpvar_89;
    tmpvar_89 = textureLod (_Inscatter, tmpvar_88.xy, 0.0);
    highp vec4 tmpvar_90;
    tmpvar_90.zw = vec2(0.0, 0.0);
    tmpvar_90.x = (((tmpvar_79 + tmpvar_77) + 1.0) / RES_NU);
    tmpvar_90.y = ((uMu_66 / RES_R) + tmpvar_82);
    lowp vec4 tmpvar_91;
    tmpvar_91 = textureLod (_Inscatter, tmpvar_90.xy, 0.0);
    inScatter0_30 = ((((tmpvar_85 * (1.0 - tmpvar_80)) + (tmpvar_87 * tmpvar_80)) * (1.0 - tmpvar_83)) + (((tmpvar_89 * (1.0 - tmpvar_80)) + (tmpvar_91 * tmpvar_80)) * tmpvar_83));
    highp float uMu_92;
    highp float uR_93;
    highp float tmpvar_94;
    tmpvar_94 = sqrt(((tmpvar_40 * tmpvar_40) - (Rg * Rg)));
    highp float tmpvar_95;
    tmpvar_95 = sqrt(((tmpvar_52 * tmpvar_52) - (Rg * Rg)));
    highp float tmpvar_96;
    tmpvar_96 = (tmpvar_52 * mu1_32);
    highp float tmpvar_97;
    tmpvar_97 = (((tmpvar_96 * tmpvar_96) - (tmpvar_52 * tmpvar_52)) + (Rg * Rg));
    highp vec4 tmpvar_98;
    if (((tmpvar_96 < 0.0) && (tmpvar_97 > 0.0))) {
      highp vec4 tmpvar_99;
      tmpvar_99.xyz = vec3(1.0, 0.0, 0.0);
      tmpvar_99.w = (0.5 - (0.5 / RES_MU));
      tmpvar_98 = tmpvar_99;
    } else {
      highp vec4 tmpvar_100;
      tmpvar_100.x = -1.0;
      tmpvar_100.y = (tmpvar_94 * tmpvar_94);
      tmpvar_100.z = tmpvar_94;
      tmpvar_100.w = (0.5 + (0.5 / RES_MU));
      tmpvar_98 = tmpvar_100;
    };
    uR_93 = ((0.5 / RES_R) + ((tmpvar_95 / tmpvar_94) * (1.0 - (1.0/(RES_R)))));
    uMu_92 = (tmpvar_98.w + ((((tmpvar_96 * tmpvar_98.x) + sqrt((tmpvar_97 + tmpvar_98.y))) / (tmpvar_95 + tmpvar_98.z)) * (0.5 - (1.0/(RES_MU)))));
    highp float y_over_x_101;
    y_over_x_101 = (max (muS1_31, -0.1975) * 5.34962);
    highp float x_102;
    x_102 = (y_over_x_101 * inversesqrt(((y_over_x_101 * y_over_x_101) + 1.0)));
    highp float tmpvar_103;
    tmpvar_103 = ((0.5 / RES_MU_S) + (((((sign(x_102) * (1.5708 - (sqrt((1.0 - abs(x_102))) * (1.5708 + (abs(x_102) * (-0.214602 + (abs(x_102) * (0.0865667 + (abs(x_102) * -0.0310296))))))))) / 1.1) + 0.74) * 0.5) * (1.0 - (1.0/(RES_MU_S)))));
    highp float tmpvar_104;
    tmpvar_104 = (((tmpvar_49 + 1.0) / 2.0) * (RES_NU - 1.0));
    highp float tmpvar_105;
    tmpvar_105 = floor(tmpvar_104);
    highp float tmpvar_106;
    tmpvar_106 = (tmpvar_104 - tmpvar_105);
    highp float tmpvar_107;
    tmpvar_107 = (floor(((uR_93 * RES_R) - 1.0)) / RES_R);
    highp float tmpvar_108;
    tmpvar_108 = (floor((uR_93 * RES_R)) / RES_R);
    highp float tmpvar_109;
    tmpvar_109 = fract((uR_93 * RES_R));
    highp vec4 tmpvar_110;
    tmpvar_110.zw = vec2(0.0, 0.0);
    tmpvar_110.x = ((tmpvar_105 + tmpvar_103) / RES_NU);
    tmpvar_110.y = ((uMu_92 / RES_R) + tmpvar_107);
    lowp vec4 tmpvar_111;
    tmpvar_111 = textureLod (_Inscatter, tmpvar_110.xy, 0.0);
    highp vec4 tmpvar_112;
    tmpvar_112.zw = vec2(0.0, 0.0);
    tmpvar_112.x = (((tmpvar_105 + tmpvar_103) + 1.0) / RES_NU);
    tmpvar_112.y = ((uMu_92 / RES_R) + tmpvar_107);
    lowp vec4 tmpvar_113;
    tmpvar_113 = textureLod (_Inscatter, tmpvar_112.xy, 0.0);
    highp vec4 tmpvar_114;
    tmpvar_114.zw = vec2(0.0, 0.0);
    tmpvar_114.x = ((tmpvar_105 + tmpvar_103) / RES_NU);
    tmpvar_114.y = ((uMu_92 / RES_R) + tmpvar_108);
    lowp vec4 tmpvar_115;
    tmpvar_115 = textureLod (_Inscatter, tmpvar_114.xy, 0.0);
    highp vec4 tmpvar_116;
    tmpvar_116.zw = vec2(0.0, 0.0);
    tmpvar_116.x = (((tmpvar_105 + tmpvar_103) + 1.0) / RES_NU);
    tmpvar_116.y = ((uMu_92 / RES_R) + tmpvar_108);
    lowp vec4 tmpvar_117;
    tmpvar_117 = textureLod (_Inscatter, tmpvar_116.xy, 0.0);
    highp vec4 tmpvar_118;
    tmpvar_118 = max ((inScatter0_30 - (((((tmpvar_111 * (1.0 - tmpvar_106)) + (tmpvar_113 * tmpvar_106)) * (1.0 - tmpvar_109)) + (((tmpvar_115 * (1.0 - tmpvar_106)) + (tmpvar_117 * tmpvar_106)) * tmpvar_109)) * extinction_29.xyzx)), vec4(0.0, 0.0, 0.0, 0.0));
    inScatter_33.xyz = tmpvar_118.xyz;
    highp float t_119;
    t_119 = max (min ((tmpvar_50 / 0.02), 1.0), 0.0);
    inScatter_33.w = (tmpvar_118.w * (t_119 * (t_119 * (3.0 - (2.0 * t_119)))));
    tmpvar_26 = (((tmpvar_118.xyz * ((3.0 / (16.0 * M_PI)) * (1.0 + (tmpvar_49 * tmpvar_49)))) + ((((tmpvar_118.xyz * inScatter_33.w) / max (tmpvar_118.x, 0.0001)) * (betaR.x / betaR)) * (((((1.5 / (4.0 * M_PI)) * (1.0 - (mieG * mieG))) * pow (((1.0 + (mieG * mieG)) - ((2.0 * mieG) * tmpvar_49)), -1.5)) * (1.0 + (tmpvar_49 * tmpvar_49))) / (2.0 + (mieG * mieG))))) * SUN_INTENSITY);
    highp float tmpvar_120;
    highp vec3 arg0_121;
    arg0_121 = (tmpvar_25 - _camPos);
    tmpvar_120 = sqrt(dot (arg0_121, arg0_121));
    highp float tmpvar_122;
    if ((tmpvar_120 <= _global_depth)) {
      tmpvar_122 = (1.0 - exp((-1.0 * ((4.0 * tmpvar_120) / _global_depth))));
    } else {
      tmpvar_122 = 1.0;
    };
    highp vec3 L_123;
    highp vec3 tmpvar_124;
    tmpvar_124 = (tmpvar_26 * _Exposure);
    L_123 = tmpvar_124;
    highp float tmpvar_125;
    if ((tmpvar_124.x < 1.413)) {
      tmpvar_125 = pow ((tmpvar_124.x * 0.38317), 0.454545);
    } else {
      tmpvar_125 = (1.0 - exp(-(tmpvar_124.x)));
    };
    L_123.x = tmpvar_125;
    highp float tmpvar_126;
    if ((tmpvar_124.y < 1.413)) {
      tmpvar_126 = pow ((tmpvar_124.y * 0.38317), 0.454545);
    } else {
      tmpvar_126 = (1.0 - exp(-(tmpvar_124.y)));
    };
    L_123.y = tmpvar_126;
    highp float tmpvar_127;
    if ((tmpvar_124.z < 1.413)) {
      tmpvar_127 = pow ((tmpvar_124.z * 0.38317), 0.454545);
    } else {
      tmpvar_127 = (1.0 - exp(-(tmpvar_124.z)));
    };
    L_123.z = tmpvar_127;
    highp vec4 tmpvar_128;
    tmpvar_128.w = 1.0;
    tmpvar_128.xyz = ((L_123 * _global_alpha) * tmpvar_122);
    tmpvar_1 = tmpvar_128;
  };
  _glesFragData[0] = tmpvar_1;
}



#endif"
}
}
Program "fp" {
SubProgram "opengl " {
"!!GLSL"
}
SubProgram "d3d9 " {
// Stats: 535 math, 18 textures, 1 branches
Matrix 0 [_ViewProjInv]
Float 4 [M_PI]
Float 5 [HR]
Vector 6 [betaR]
Float 7 [HM]
Vector 8 [betaMEx]
Float 9 [mieG]
Float 10 [Rg]
Float 11 [Rt]
Float 12 [RES_R]
Float 13 [RES_MU]
Float 14 [RES_MU_S]
Float 15 [RES_NU]
Vector 16 [SUN_DIR]
Float 17 [SUN_INTENSITY]
Float 18 [_experimentalAtmoScale]
Float 19 [_global_alpha]
Float 20 [_Exposure]
Float 21 [_global_depth]
Vector 22 [_camPos]
Float 23 [_openglThreshold]
SetTexture 0 [_customDepthTexture] 2D 0
SetTexture 1 [_godrayDepthTexture] 2D 1
SetTexture 2 [_Inscatter] 2D 2
"ps_3_0
dcl_2d s0
dcl_2d s1
dcl_2d s2
def c24, 0.00000000, 1.00000000, -1.00000000, 2.00000000
def c25, 4.00000000, 16.00000000, 0.89999998, 1000000015047466200000000000000.00000000
def c26, 1600.00000000, -0.19750001, 5.34960032, -0.12123910
def c27, -0.01348047, 0.05747731, 0.19563590, -0.33299461
def c28, 0.99999559, 1.57079601, 0.90909088, 0.74000001
def c29, 0.50000000, 6.28310013, 2.71828198, 2.31929994
def c30, 1.51999998, 4.00000000, 3.00000000, -1.50000000
def c31, 50.00000000, 2.00000000, 3.00000000, 0.00010000
def c32, 1.50000000, -1.41299999, 0.38317001, 0.45454544
dcl_texcoord2 v0.xy
texld r0.x, v0, s0
mad r3.xy, v0, c24.w, c24.z
mov r4.xy, r3
mov r4.z, r0.x
mov r4.w, c24.y
dp4 r0.z, r4, c3
mov r3.w, c24.y
add r1.w, r0.x, c24.z
dp4 r1.z, r4, c2
dp4 r1.y, r4, c1
dp4 r1.x, r4, c0
rcp r0.z, r0.z
mad r1.xyz, r1, r0.z, -c22
mov r4.xyz, c22
mul r5.xyz, c16.yzxw, r4.zxyw
dp3 r0.w, r1, r1
mov r4.xyz, c22
mad r4.xyz, c16.zxyw, r4.yzxw, -r5
rsq r0.w, r0.w
dp3 r0.z, r4, r4
mul r5.xyz, r0.w, r1
rsq r0.z, r0.z
mul r1.xyz, r0.z, r4
dp3 r0.z, r1, r5
texld r1.x, v0, s1
abs r0.z, r0
add r0.w, r1.x, -r0.x
add r0.z, -r0, c24.y
mad r1.z, r0, r0.w, r0.x
add r0.z, r1.x, -r0.x
cmp r0.w, r0.z, c24.x, c24.y
cmp r0.z, -r1.x, c24.x, c24.y
mul_pp r0.z, r0, r0.w
cmp r1.y, r1.w, c24.x, c24
mul_pp r0.z, r0, r1.y
cmp r3.z, -r0, r0.x, r1
dp4 r0.x, r3, c3
dp4 r1.z, r3, c2
dp4 r1.y, r3, c1
dp4 r1.x, r3, c0
rcp r0.x, r0.x
mov r3.xyz, c22
mul r1.xyz, r1, r0.x
dp3 r0.z, c24.x, r3
dp3 r0.x, c22, c22
add r0.x, r0, -r0.z
add r3.xyz, r1, -c22
dp3 r0.z, r3, r3
mad r0.x, -c10, c10, r0
mul r0.w, r0.z, r0.x
dp3 r0.x, r3, c22
mul r0.x, r0, c24.w
mul r0.w, r0, c25.x
mad r0.w, r0.x, r0.x, -r0
cmp_pp r3.x, r0.w, c24.y, c24
cmp r0.y, r0.w, r0, c24.z
rsq r0.w, r0.w
mul r3.y, r0.z, c24.w
rcp r0.z, r0.w
add r0.x, -r0, -r0.z
rcp r0.w, r3.y
mul r0.x, r0, r0.w
cmp r0.y, -r3.x, r0, r0.x
cmp r0.x, -r0.y, c24, c24.y
abs_pp r0.z, r0.x
abs r0.w, r1
cmp r0.w, -r0, c24.y, c24.x
cmp_pp r0.z, -r0, c24.y, c24.x
mul_pp r0.z, r0, r0.w
cmp_pp r0.w, -r0.z, c24.y, c24.x
cmp_pp oC0, -r0.z, r2, c24.x
if_gt r0.w, c24.x
add r2.xyz, r1, -c22
rcp r10.y, c12.x
mul r3.xyz, r0.y, r2
dp3 r0.z, r2, r2
dp3 r0.y, r3, r3
add r2.xyz, r3, c22
rcp r7.w, c14.x
rsq r0.z, r0.z
rsq r0.y, r0.y
mov r5.xz, c22
rcp r9.z, c15.x
add r8.w, -r7, c24.y
mul r9.w, c10.x, c10.x
mov r3.x, c24.z
rcp r13.y, c5.x
rcp r0.z, r0.z
rcp r0.y, r0.y
add r0.y, r0, -r0.z
cmp r0.y, r0, c24.x, c24
mul_pp r0.x, r0, r0.y
cmp r0.xyz, -r0.x, r1, r2
dp3 r0.w, r0, r0
rsq r0.w, r0.w
mul r2.xyz, r0.w, r0
mov r1.x, c10
add r1.x, c23, r1
rcp r0.w, r0.w
mul r2.xyz, r1.x, r2
add r0.w, r0, -r1.x
cmp r0.xyz, r0.w, r0, r2
add r1.xyz, r0, -c22
dp3 r0.w, r1, r1
rsq r1.w, r0.w
mul r1.xyz, r1.w, r1
dp3 r0.w, r1, r1
rsq r2.x, r0.w
mul r6.xyz, r2.x, r1
mov r0.w, c22.y
add r2.w, c10.x, r0
dp3 r2.y, c22, c22
rsq r2.y, r2.y
rcp r6.w, r1.w
dp3 r5.w, r6, c16
rcp r2.y, r2.y
mov r0.w, c10.x
mad r2.z, c25, -r0.w, r2.y
cmp r5.y, r2.z, c22, r2.w
dp3 r0.w, r5, r5
rsq r0.w, r0.w
rcp r1.x, r0.w
cmp r12.x, r2.z, r2.y, r1
mov r0.w, c11.x
add r0.w, -c10.x, r0
mul r0.w, r0, c18.x
dp3 r11.z, r6, r5
mul r1.x, r12, r12
add r11.w, r0, c10.x
mad r1.x, r11.z, r11.z, -r1
mad r0.w, r11, r11, r1.x
rsq r1.x, r0.w
rcp r1.x, r1.x
cmp r0.w, r0, r1.x, c25
add r0.w, -r11.z, -r0
max r11.y, r0.w, c24.x
add r0.w, r11.y, -r6
cmp r1.x, r0.w, c24, c24.y
cmp r0.w, -r11.y, c24.x, c24.y
mul_pp r12.z, r0.w, r1.x
cmp r7.z, -r12, r12.x, r11.w
add r1.x, r0.y, c10
mov r0.w, c10.x
add r12.y, c26.x, r0.w
rcp r12.w, r7.z
add r13.z, r7, -r12.y
cmp r0.y, r2.z, r0, r1.x
mov_sat r0.w, r6
mad r0.xyz, -r6, r0.w, r0
mul r1.y, r12, r12.w
mul r1.xyz, r0, r1.y
cmp r0.xyz, r13.z, r0, r1
dp3 r0.w, r0, r0
dp3 r1.x, r0, c16
dp3 r0.x, r6, r0
rsq r0.w, r0.w
mad r0.z, r11.w, r11.w, -r9.w
mul r1.x, r0.w, r1
max r1.x, r1, c26.y
mul r1.x, r1, c26.z
abs r1.y, r1.x
max r1.z, r1.y, c24.y
rcp r1.w, r1.z
min r1.z, r1.y, c24.y
mul r1.z, r1, r1.w
mul r1.w, r1.z, r1.z
mad r2.x, r1.w, c27, c27.y
mad r2.x, r2, r1.w, c26.w
mad r2.x, r2, r1.w, c27.z
mad r2.x, r2, r1.w, c27.w
mad r1.w, r2.x, r1, c28.x
mul r1.z, r1.w, r1
rsq r10.x, r0.z
add r1.w, -r1.z, c28.y
add r1.y, r1, c24.z
cmp r1.y, -r1, r1.z, r1.w
cmp r1.x, r1, r1.y, -r1.y
mov r1.y, c15.x
add r1.z, c24, r1.y
add r1.y, r5.w, c24
mul r1.y, r1, r1.z
rcp r1.z, r0.w
mul r1.y, r1, c29.x
frc r9.x, r1.y
mad r1.x, r1, c28.z, c28.w
add r11.x, -r9, c24.y
add r9.y, r1, -r9.x
mad r1.x, r1, r8.w, r7.w
mad r1.x, r1, c29, r9.y
mul r8.x, r1, r9.z
add r1.y, r1.x, c24
mul r7.x, r9.z, r1.y
rcp r1.y, c13.x
mul r0.x, r0.w, r0
mul r1.x, r1.z, r0
mul r0.y, r1.z, r1.z
mad r0.y, r1.x, r1.x, -r0
mad r1.w, c10.x, c10.x, r0.y
mad r1.z, r1, r1, -r9.w
rsq r1.z, r1.z
mad r3.w, r1.y, c29.x, c29.x
cmp r0.y, -r1.w, c24.x, c24
cmp r0.x, r1, c24, c24.y
mul_pp r0.x, r0, r0.y
rcp r0.y, r10.x
mul r3.y, r0, r0
mov r3.z, r0.y
mad r2.w, -r1.y, c29.x, c29.x
mov r2.xyz, c24.yxxw
cmp r0, -r0.x, r3, r2
add r0.y, r0, r1.w
rcp r1.z, r1.z
rsq r0.y, r0.y
rcp r0.y, r0.y
mad r0.x, r1, r0, r0.y
add r0.y, r0.z, r1.z
mul r1.w, r10.x, r1.z
add r10.z, -r10.y, c24.y
rcp r0.y, r0.y
mul r1.w, r1, r10.z
mad r1.w, r10.y, c29.x, r1
mul r4.w, r1, c12.x
add r0.z, r4.w, c24
mul r0.x, r0, r0.y
frc r1.x, r0.z
add r0.y, r0.z, -r1.x
add r10.w, -r1.y, c29.x
frc r13.x, r4.w
mov r4.x, r8
mad r7.y, r0.x, r10.w, r0.w
mul r0.y, r0, r10
mad r1.y, r7, r10, r0
mov r4.y, r1
mov r4.z, c24.x
texldl r0, r4.xyzz, s2
add r4.x, r4.w, -r13
mul r8.y, r10, r4.x
mad r7.y, r7, r10, r8
mov r8.y, r7
mov r1.x, r7
mov r1.z, c24.x
texldl r1, r1.xyzz, s2
mul r1, r9.x, r1
mad r4, r0, r11.x, r1
mov r8.z, c24.x
texldl r0, r8.xyzz, s2
cmp r8.z, r13, r7, r12.y
mul r1.x, r8.z, r13.y
mul r8.x, r1, c29
mov r7.z, c24.x
texldl r1, r7.xyzz, s2
rcp r7.x, r12.x
rsq r8.x, r8.x
add r7.z, -r11.y, r6.w
mul r1, r9.x, r1
mad r1, r11.x, r0, r1
cmp r7.z, -r12, r6.w, r7
rcp r7.y, r8.z
add r8.y, r11, r11.z
rcp r11.w, r11.w
mul r8.y, r8, r11.w
mul r7.x, r11.z, r7
cmp r7.x, -r12.z, r7, r8.y
mad r7.y, r7.z, r7, r7.x
rcp r8.x, r8.x
mul r11.zw, r8.x, r7.xyxy
mul r8.xy, r11.zwzw, r11.zwzw
mad r0.xy, r8, c30.x, c30.y
mul r8.y, r8.z, c24.w
rsq r0.x, r0.x
rsq r0.y, r0.y
rcp r8.y, r8.y
mad r8.y, r7.z, r8, r7.x
cmp r0.zw, -r11, c24.x, c24.y
cmp r12.xy, r11.zwzw, c24.x, c24.y
add r12.xy, r0.zwzw, -r12
abs r0.zw, r11
rcp r0.x, r0.x
rcp r0.y, r0.y
mad r11.zw, r0, c29.w, r0.xyxy
mul r0.x, r13.y, -r7.z
mul r13.z, r0.x, r8.y
pow r0, c29.z, r13.z
rcp r11.z, r11.z
rcp r11.w, r11.w
mul r0.zw, r12.xyxy, r11
mov r0.x, c24.y
mul r11.zw, r0, r0.xyxy
mul r0, r13.x, r1
add r1.x, -r13, c24.y
mad r1, r4, r1.x, r0
mul r11.zw, r11, c24.xyyz
pow r0, c29.z, r8.x
add r4.x, r12.y, -r12
rcp r12.x, c7.x
mul r0.y, r8.z, r12.x
mul r0.y, r0, c29.x
rsq r0.y, r0.y
rcp r0.y, r0.y
mul r4.zw, r7.xyxy, r0.y
add r4.y, r11.z, r11.w
add r8.x, -r8.z, c10
cmp r0.x, -r4, c24, r0
add r11.z, r0.x, r4.y
mul r11.w, r8.x, r13.y
mul r4.xy, r4.zwzw, r4.zwzw
pow r0, c29.z, r11.w
mul r7.y, r8.z, c5.x
mul r0.y, r7, c29
mov r0.z, r0.x
rsq r0.y, r0.y
rcp r0.x, r0.y
mul r0.x, r0, r0.z
mul r7.y, r0.x, r11.z
mad r0.xy, r4, c30.x, c30.y
rsq r0.y, r0.y
rsq r0.x, r0.x
abs r0.zw, r4
rcp r0.y, r0.y
rcp r0.x, r0.x
mad r0.xy, r0.zwzw, c29.w, r0
cmp r0.zw, r4, c24.x, c24.y
cmp r4.zw, -r4, c24.x, c24.y
add r4.zw, r4, -r0
mul r0.w, -r7.z, r12.x
mul r4.y, r8, r0.w
rcp r11.z, r0.x
rcp r11.w, r0.y
mad r0.xyz, r6, r11.y, r5
cmp r0.xyz, -r12.z, r5, r0
mul r6.xy, r4.zwzw, r11.zwzw
dp3 r0.x, r0, c16
mul r5.x, r12.w, r0
pow r0, c29.z, r4.y
max r0.x, r5, c26.y
mul r4.y, r0.x, c26.z
abs r5.y, r4
max r0.z, r5.y, c24.y
rcp r0.w, r0.z
mov r0.x, c24.y
mul r0.xy, r6, r0
min r0.z, r5.y, c24.y
mul r6.x, r0.z, r0.w
mul r0.xy, r0, c24.yzzw
add r5.z, r0.x, r0.y
pow r0, c29.z, r4.x
mul r6.y, r6.x, r6.x
add r4.z, r4.w, -r4
mad r4.w, r6.y, c27.x, c27.y
mad r0.y, r4.w, r6, c26.w
cmp r0.x, -r4.z, c24, r0
mad r0.y, r0, r6, c27.z
mad r0.y, r0, r6, c27.w
mad r0.y, r0, r6, c28.x
add r4.w, r0.x, r5.z
mul r5.z, r0.y, r6.x
mul r4.z, r8.x, r12.x
pow r0, c29.z, r4.z
mul r4.x, r8.z, c7
mul r0.y, r4.x, c29
mov r0.z, r0.x
rsq r0.y, r0.y
rcp r0.x, r0.y
mul r0.x, r0, r0.z
add r0.y, r5, c24.z
add r0.z, -r5, c28.y
cmp r0.w, -r0.y, r5.z, r0.z
mul r0.x, r0, r4.w
cmp r0.w, r4.y, r0, -r0
mul r0.xyz, r0.x, c8
mad r4.xyz, r7.y, -c6, -r0
mad r4.w, r0, c28.z, c28
pow r0, c29.z, r4.x
mad r0.y, r8.w, r4.w, r7.w
mad r0.z, r0.y, c29.x, r9.y
add r4.w, r0.z, c24.y
mul r8.x, r9.z, r4.w
mul r0.y, r8.z, r7.x
mul r0.w, r8.z, r8.z
mad r0.w, r0.y, r0.y, -r0
mad r4.x, c10, c10, r0.w
mad r5.y, r8.z, r8.z, -r9.w
cmp r4.w, -r4.x, c24.x, c24.y
cmp r0.w, r0.y, c24.x, c24.y
mul_pp r0.w, r0, r4
cmp r2, -r0.w, r3, r2
add r0.w, r2.y, r4.x
rsq r4.w, r5.y
rcp r3.x, r4.w
mul r2.y, r10.x, r3.x
rsq r0.w, r0.w
mul r2.y, r10.z, r2
rcp r0.w, r0.w
mad r0.w, r0.y, r2.x, r0
add r2.x, r2.z, r3
rcp r2.x, r2.x
mul r0.w, r0, r2.x
mad r2.y, r10, c29.x, r2
mul r2.y, r2, c12.x
frc r0.y, r2
add r2.z, r2.y, -r0.y
mad r0.w, r10, r0, r2
mul r2.x, r10.y, r2.z
mad r8.y, r10, r0.w, r2.x
add r2.x, r2.y, c24.z
frc r2.y, r2.x
add r2.x, r2, -r2.y
mov r8.z, c24.x
texldl r3, r8.xyzz, s2
mov r6.x, r8
mul r2.x, r10.y, r2
mad r6.y, r10, r0.w, r2.x
mov r6.z, c24.x
texldl r2, r6.xyzz, s2
mul r7, r9.x, r3
mul r8.x, r9.z, r0.z
mov r8.z, c24.x
texldl r3, r8.xyzz, s2
mad r3, r11.x, r3, r7
mul r7, r9.x, r2
mul r3, r0.y, r3
add r0.y, -r0, c24
mov r4.x, r0
mov r2.x, r8
mov r2.z, c24.x
mov r2.y, r6
texldl r2, r2.xyzz, s2
mad r2, r11.x, r2, r7
mad r2, r2, r0.y, r3
pow r0, c29.z, r4.z
pow r3, c29.z, r4.y
mul_sat r3.x, r5, c31
mov r4.y, r3
mov r4.z, r0
min r0.xyz, r4, c24.y
mad r0, -r1, r0.xyzx, r2
mad r1.y, -r3.x, c31, c31.z
mul r1.x, r3, r3
mul r2.x, r1, r1.y
max r1, r0, c24.x
mul r0.y, r1.w, r2.x
mul r2.xyz, r1, r0.y
max r0.y, r1.x, c31.w
rcp r0.y, r0.y
mul r3.xyz, r2, r0.y
mul r0.x, r5.w, c9
mul r0.x, r0, c24.w
mad r0.x, c9, c9, -r0
add r1.w, r0.x, c24.y
pow r0, r1.w, c30.w
mov r0.w, r0.x
mul r0.z, -c9.x, c9.x
add r0.y, r0.z, c24
mov r0.x, c4
mul r0.x, c25, r0
rcp r0.x, r0.x
mul r0.x, r0, r0.y
add r0.z, -r0, c24.w
mul r0.x, r0, r0.w
mad r0.y, r5.w, r5.w, c24
mul r0.w, r0.y, r0.x
mov r0.x, c4
rcp r0.z, r0.z
mul r0.x, c25.y, r0
rcp r0.x, r0.x
mul r0.z, r0.w, r0
rcp r2.x, c6.x
rcp r2.z, c6.z
rcp r2.y, c6.y
mul r2.xyz, r2, c6.x
mul r2.xyz, r3, r2
mul r2.xyz, r0.z, r2
mul r0.x, r0, r0.y
mul r2.xyz, r2, c32.x
mul r0.xyz, r0.x, r1
mad r0.xyz, r0, c30.z, r2
mul r0.xyz, r0, c17.x
mul r3.xyz, r0, c20.x
mul r2.y, r3.z, c32.z
pow r0, r2.y, c32.w
pow r1, c29.z, -r3.z
mov r0.y, r1.x
pow r1, c29.z, -r3.x
mov r0.z, r0.x
add r1.y, r3, c32
mul r1.z, r3.y, c32
add r2.x, r3.z, c32.y
add r0.x, -r0.y, c24.y
cmp r3.z, r2.x, r0.x, r0
pow r0, r1.z, c32.w
pow r2, c29.z, -r3.y
mov r0.y, r2.x
mov r0.z, r0.x
add r0.x, -r0.y, c24.y
rcp r0.y, c21.x
mul r0.y, r6.w, r0
cmp r3.y, r1, r0.x, r0.z
mov r0.x, r1
add r2.y, -r0.x, c24
mul r0.x, r3, c32.z
pow r1, r0.x, c32.w
mul r2.z, r0.y, c25.x
pow r0, c29.z, -r2.z
mov r0.y, r1.x
add r2.x, r3, c32.y
cmp r3.x, r2, r2.y, r0.y
add r0.y, -r0.x, c24
add r0.x, r6.w, -c21
cmp r0.w, -r0.x, r0.y, c24.y
mul r0.xyz, r3, c19.x
mul oC0.xyz, r0, r0.w
mov oC0.w, c24.y
endif
"
}
SubProgram "d3d11 " {
// Stats: 360 math, 2 textures, 2 branches
SetTexture 0 [_customDepthTexture] 2D 1
SetTexture 1 [_godrayDepthTexture] 2D 2
SetTexture 2 [_Inscatter] 2D 0
ConstBuffer "$Globals" 384
Matrix 160 [_ViewProjInv]
Float 32 [M_PI]
Float 52 [HR]
Vector 64 [betaR] 3
Float 76 [HM]
Vector 96 [betaMEx] 3
Float 108 [mieG]
Float 112 [Rg]
Float 116 [Rt]
Float 124 [RES_R]
Float 128 [RES_MU]
Float 132 [RES_MU_S]
Float 136 [RES_NU]
Vector 144 [SUN_DIR] 3
Float 156 [SUN_INTENSITY]
Float 228 [_experimentalAtmoScale]
Float 236 [_global_alpha]
Float 240 [_Exposure]
Float 244 [_global_depth]
Vector 272 [_camPos] 3
Float 304 [_openglThreshold]
BindCB  "$Globals" 0
"ps_4_0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"
}
SubProgram "gles " {
"!!GLES"
}
SubProgram "glesdesktop " {
"!!GLES"
}
SubProgram "gles3 " {
"!!GLES3"
}
}
 }
}
}